-- Copyright (c) 2007-2008 Alexander Zenkov

-- This program is free software: you can redistribute it and/or modify 
-- it under the terms of the GNU General Public License as published by 
-- the Free Software Foundation, either version 3 of the License, or 
-- (at your option) any later version.

-- This program is distributed in the hope that it will be useful, 
-- but WITHOUT ANY WARRANTY; without even the implied warranty of 
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
-- GNU General Public License for more details.

-- You should have received a copy of the GNU General Public License 
-- along with this program. If not, see http://www.gnu.org/licenses/.

-- Full license text: http://www.gnu.org/licenses/gpl.txt

-- Description: Multifunctional script for Verlihub
-- Contact email: hundrambit@gmail.com
-- Website: http://kompozitor.gotdns.org/ledokol.php

-- developer @todo list begin

-- empty

-- developer @todo list end

-- ledokol version stuff begin

ledover = "2.1.1"
ledoverdns = "kompozitor.gotdns.org"
ledoverdir = "/tmp/"
ledoverfile = "ledokol.ver"

-- ledokol version stuff end

-- antispam stuff begin

command_antiadd = "antiadd"
command_antimod = "antimod"
command_antidel = "antidel"
command_antilist = "antilist"
command_exadd = "exadd"
command_exdel = "exdel"
command_exlist = "exlist"

enableantispam = 1
scanbelowclass = 3
allowspamtoops = 1

thirdacttime = "1d"
antikreason = "Forbidden message detected"
antimessage = "Your message wasn't sent due spam detection. In case you disagree with this decision you will need to contact hub administration."

-- antispam stuff end

-- topic stuff begin

command_topic = "topic"
command_showtopic = "showtopic"

showtopicowner = 1

topicowner = nil
topicvalue = nil

-- topic stuff end

-- reminder stuff begin

command_remind = "remind"

remrunning = 0
rempmmode = 0
reminterval = 3600
remminclass = 0
remmaxclass = 10
remseconds = 0 -- don't change

remtext = "This hub is running Ledokol. Please visit http://"..ledoverdns.."/ledokol.php for more information."

-- reminder stuff end

-- myinfo stuff begin

command_myinfadd = "myinfadd"
command_myinfdel = "myinfdel"
command_myinflist = "myinflist"

micheck = 1
michnick = 1
michdesc = 1
michtag = 1
michconn = 1
michemail = 1
michshare = 1
michclone = 0

mitbantime = "1h"

minickmessage = "Forbidden nick detected"
midescmessage = "Forbidden description detected"
mitagmessage = "Forbidden tag detected: *"
miconnmessage = "Forbidden connection type detected: *"
miemailmessage = "Forbidden email detected"
misharemessage = "Forbidden share size detected: *"
miclonemessage = "Share clone of yourself detected: *"

-- myinfo stuff end

-- offline stuff begin

command_offlist = "offlist"
command_offdel = "offdel"
command_offclean = "offclean"
command_offmsg = "offmsg"

offrunning = 1

-- offline stuff end

-- history stuff begin

command_histclean = "histclean"
command_ophist = "ophist"
command_history = "history"

histrunning = 0
histbotmsg = 1
histlimit = 100

-- history stuff end

-- reglist stuff begin

command_reglist = "reglist"

-- reglist stuff end

-- say stuff begin

command_say = "say"

-- say stuff end

-- rank stuff begin

command_chatrandel = "chatrandel"
command_oprandel = "oprandel"
command_mychatrank = "mychatrank"
command_myoprank = "myoprank"
command_chatranks = "chatranks"
command_opranks = "opranks"

enablechatranks = 0
enableopranks = 0
ranklimit = 25

-- rank stuff end

-- notification stuff begin

notifytoledobot = 1

notifyanti = 1
notifyex = 1
notifycom = 1
notifysay = 1
notifykick = 1
notifyban = 1
notifyconfig = 1
notifyredir = 1
notifyunk = 1
notifymyinf = 1
notifymyinfex = 1
notifyoff = 1
notifyledoact = 1

classnotianti = 3
classnotiex = 3
classnoticom = 5
classnotisay = 3
classnotikick = 3
classnotiban = 3
classnoticonfig = 5
classnotiredir = 3
classnotiunk = 5
classnotimyinf = 3
classnotimyinfex = 3
classnotioff = 3
classnotiledoact = 5

-- notofication stuff end

-- verlihub databse stuff begin

command_cleanup = "cleanup"

-- verlihub databse stuff end

-- ledokol own stuff begin

table_lang = {

["lang_000"] = "No topic is set.", 
["lang_001"] = "Current topic: %s", 
["lang_002"] = "Current topic set by %s: %s", 
["lang_003"] = "%s with IP %s was kicked for %s due share clone detection: %s with IP %s", 
["lang_004"] = "days", 
["lang_005"] = "%s deleted IP log entries older than %s days.", 
["lang_006"] = "%s deleted unbans older than %s days.", 
["lang_007"] = "%s deleted bans older than %s days.", 
["lang_008"] = "%s deleted kicks older than %s days.", 
["lang_009"] = "I don't accept private messages.", 
["lang_010"] = "Check for new version", 
["lang_011"] = "Successfully deleted %s main chat history messages.", 
["lang_012"] = "There are no main chat history messages to remove.", 
["lang_013"] = "Successfully deleted %s operator chat history messages.", 
["lang_014"] = "There are no operator chat history messages to remove.", 
["lang_015"] = "%s deleted all history messages.", 
["lang_016"] = "Couldn't write temporary version file. Check the permissions.", 
["lang_017"] = "Last %s main chat messages", 
["lang_018"] = "Main chat history is empty.", 
["lang_019"] = "Couldn't download version file from target server. Please try again later.", 
["lang_020"] = "Main chat history is not available.", 
["lang_021"] = "Last %s operator chat messages", 
["lang_022"] = "Operator chat history is empty.", 
["lang_023"] = "Operator chat history is not available.", 
["lang_024"] = "Ledokol version %s has been released. Please visit %s to download it.", 
["lang_025"] = "You are currently running latest version of Ledokol. No upgrade is needed.", 
["lang_026"] = "Why would you send offline message to yourself?", 
["lang_027"] = "User %s is online. Sending message directly.", 
["lang_028"] = "Your offline message to %s was successfully stored.", 
["lang_029"] = "%s with IP %s sent offline message.", 
["lang_030"] = "Offline messenger is not available.", 
["lang_031"] = "No", 
["lang_032"] = "Yes", 
["lang_033"] = "Following offline message was sent to you on %s", 
["lang_034"] = "Sender is online", 
["lang_035"] = "%s with IP %s received offline messages.", 
["lang_036"] = "Stored offline messages", 
["lang_037"] = "Offline message list is empty.", 
["lang_038"] = "Successfully deleted %s offline messages.", 
["lang_039"] = "Couldn't delete offline messages because not found: %s", 
["lang_040"] = "%s deleted all offline messages.", 
["lang_041"] = "There are no offline messages to remove.", 
["lang_042"] = "Reminder is not available.", 
["lang_043"] = "%s with IP %s was allowed due forbidden nick exception: %s", 
["lang_044"] = "%s with IP %s was kicked for %s due forbidden nick detection: %s", 
["lang_045"] = "%s with IP %s was allowed due forbidden description exception: %s", 
["lang_046"] = "%s with IP %s was kicked for %s due forbidden description detection: %s", 
["lang_047"] = "%s with IP %s was allowed due forbidden tag exception: %s", 
["lang_048"] = "%s with IP %s was kicked for %s due forbidden tag detection: %s", 
["lang_049"] = "%s with IP %s was allowed due forbidden connection type exception: %s", 
["lang_050"] = "%s with IP %s was kicked for %s due forbidden connection type detection: %s", 
["lang_051"] = "%s with IP %s was allowed due forbidden email exception: %s", 
["lang_052"] = "%s with IP %s was kicked for %s due forbidden email detection: %s", 
["lang_053"] = "%s with IP %s was allowed due forbidden share size exception: %s", 
["lang_054"] = "%s with IP %s was kicked for %s due forbidden share size detection: %s", 
["lang_055"] = "Why would you want to set empty topic?", 
["lang_056"] = "Couldn't add forbidden nick because already exists: %s", 
["lang_057"] = "Successfully added forbidden nick: %s", 
["lang_058"] = "Couldn't add forbidden description because already exists: %s", 
["lang_059"] = "Successfully added forbidden description: %s", 
["lang_060"] = "Couldn't add forbidden tag because already exists: %s", 
["lang_061"] = "Successfully added forbidden tag: %s", 
["lang_062"] = "Couldn't add forbidden connection type because already exists: %s", 
["lang_063"] = "Successfully added forbidden connection type: %s", 
["lang_064"] = "Couldn't add forbidden email because already exists: %s", 
["lang_065"] = "Successfully added forbidden email: %s", 
["lang_066"] = "Couldn't add forbidden share size because already exists: %s", 
["lang_067"] = "Successfully added forbidden share size: %s", 
["lang_068"] = "Couldn't add MyINFO exception because already exists: %s", 
["lang_069"] = "Successfully added MyINFO exception: %s", 
["lang_070"] = "and", 
["lang_071"] = "Successfully deleted forbidden nick: %s", 
["lang_072"] = "Couldn't delete forbidden nick because not found: %s", 
["lang_073"] = "Successfully deleted forbidden description: %s", 
["lang_074"] = "Couldn't delete forbidden description because not found: %s", 
["lang_075"] = "Successfully deleted forbidden tag: %s", 
["lang_076"] = "Couldn't delete forbidden tag because not found: %s", 
["lang_077"] = "Successfully deleted forbidden connection type: %s", 
["lang_078"] = "Couldn't delete forbidden connection type because not found: %s", 
["lang_079"] = "Successfully deleted forbidden email: %s", 
["lang_080"] = "Couldn't delete forbidden email because not found: %s", 
["lang_081"] = "Successfully deleted forbidden share size: %s", 
["lang_082"] = "Couldn't delete forbidden share size because not found: %s", 
["lang_083"] = "Successfully deleted MyINFO exception: %s", 
["lang_084"] = "Couldn't delete MyINFO exception because not found: %s", 
["lang_085"] = "Forbidden nick list", 
["lang_086"] = "Forbidden nick list is empty.", 
["lang_087"] = "Forbidden description list", 
["lang_088"] = "Forbidden description list is empty.", 
["lang_089"] = "Forbidden tag list", 
["lang_090"] = "Forbidden tag list is empty.", 
["lang_091"] = "Forbidden connection type list", 
["lang_092"] = "Forbidden connection type list is empty.", 
["lang_093"] = "Forbidden email list", 
["lang_094"] = "Forbidden email list is empty.", 
["lang_095"] = "Forbidden share size list", 
["lang_096"] = "Forbidden share size list is empty.", 
["lang_097"] = "MyINFO exception list", 
["lang_098"] = "MyINFO exception list is empty.", 
["lang_099"] = "Successfully deleted %s rows: %s", 
["lang_100"] = "Known types are: %s", 
["lang_101"] = "No rows to remove: %s", 
["lang_102"] = "date", 
["lang_103"] = "%s with class %s used following command: %s", 
["lang_104"] = "%s was permanently banned: <%s> %s", 
["lang_105"] = "User was successfully deleted from chat rank list: %s", 
["lang_106"] = "User was not found in chat rank list: %s", 
["lang_107"] = "User was successfully deleted from operator rank list: %s", 
["lang_108"] = "User was not found in operator rank list: %s", 
["lang_109"] = "Chat ranking is disabled.", 
["lang_110"] = "Your chat rank is: %s", 
["lang_111"] = "Write something in main chat to get started.", 
["lang_112"] = "You are not operator.", 
["lang_113"] = "Operator ranking is disabled.", 
["lang_114"] = "Your operator rank is: %s", 
["lang_115"] = "Use any operator command to get started.", 
["lang_116"] = "Top %s chat rankers", 
["lang_117"] = "Chat rank list is empty.", 
["lang_118"] = "Top %s operator rankers", 
["lang_119"] = "Operator rank list is empty.", 
["lang_120"] = "skip", 
["lang_121"] = "drop", 
["lang_122"] = "kick", 
["lang_123"] = "temporary ban", 
["lang_124"] = "Couldn't add antispam entry because already exists: %s", 
["lang_125"] = "Successfully added antispam entry with %s action: %s", 
["lang_126"] = "Couldn't modify antispam entry because already has same action: %s", 
["lang_127"] = "Successfully modified antispam entry from %s to %s action: %s", 
["lang_128"] = "Couldn't modify antispam entry because not found: %s", 
["lang_129"] = "Successfully deleted antispam entry: %s", 
["lang_130"] = "Couldn't delete antispam entry because not found: %s", 
["lang_131"] = "Antispam list", 
["lang_132"] = "Antispam list is empty.", 
["lang_133"] = "Couldn't add exception entry because already exists: %s", 
["lang_134"] = "Successfully added exception entry: %s", 
["lang_135"] = "Successfully deleted exception entry: %s", 
["lang_136"] = "Couldn't delete exception entry because not found: %s", 
["lang_137"] = "Exception list", 
["lang_138"] = "Exception list is empty.", 
["lang_139"] = "Offset numbers can't be negative and #x0 will result nothing.", 
["lang_140"] = "Offset numbers can't be negative and you can't start from user number %s when you only have %s registered users with class %s.", 
["lang_141"] = "Showing %s out of totally %s registered users with class %s starting at user number %s", 
["lang_142"] = "There are no registered users with class: %s", 
["lang_143"] = "Invalid Verlihub class: %s", 
["lang_144"] = "%s with class %s sent following say message: <%s> %s", 
["lang_145"] = "%s with class %s had bad luck sending following say message: <%s> %s", 
["lang_146"] = "You can't talk from nick whose class is higher or equals your own.", 
["lang_147"] = "%s with IP %s was kicked: <%s> %s", 
["lang_148"] = "%s with IP %s was kicked by %s", 
["lang_149"] = "offset", 
["lang_150"] = "%s was unbanned: <%s> %s", 
["lang_151"] = "%s with IP %s was redirected: <%s> %s", 
["lang_152"] = "%s with IP %s was redirected to %s: <%s> %s", 
["lang_153"] = "%s with IP %s sent unknown protocol message: %s", 
["lang_154"] = "Reminder is not available for your class.", 
["lang_155"] = "Ledokol operator commands", 
["lang_156"] = "Add antispam entry", 
["lang_157"] = "Modify antispam entry", 
["lang_158"] = "Delete antispam entry", 
["lang_159"] = "Add exception entry", 
["lang_160"] = "Delete exception entry", 
["lang_161"] = "Add MyINFO entry", 
["lang_162"] = "Delete MyINFO entry", 
["lang_163"] = "MyINFO list", 
["lang_164"] = "List of registered users by class", 
["lang_165"] = "Speak from other nick", 
["lang_166"] = "Remove user from chat rank list", 
["lang_167"] = "Remove user from operator rank list", 
["lang_168"] = "List stored offline messages", 
["lang_169"] = "Delete offline messages by date", 
["lang_170"] = "Delete all offline messages", 
["lang_171"] = "class", 
["lang_172"] = "Clean up tables", 
["lang_173"] = "Operator chat history", 
["lang_174"] = "Delete all history messages", 
["lang_175"] = "Your operator rank", 
["lang_176"] = "Ledokol configuration variables", 
["lang_177"] = "Change configuration variable", 
["lang_178"] = "%s with IP %s and class %s had bad luck redirecting %s: %s", 
["lang_179"] = "This help text", 
["lang_180"] = "Ledokol user commands", 
["lang_181"] = "Current topic", 
["lang_182"] = "Your chat rank", 
["lang_183"] = "%s with IP %s and class %s sent following spam message exception in main chat: %s", 
["lang_184"] = "%s with IP %s and class %s had bad luck sending following spam message in main chat: %s", 
["lang_185"] = "Reminder message", 
["lang_186"] = "Offline message to user", 
["lang_187"] = "Main chat history", 
["lang_188"] = "Statistics", 
["lang_189"] = "Ledokol version: %s", 
["lang_190"] = "Total chat rank points: %s", 
["lang_191"] = "Total operator rank points: %s", 
["lang_192"] = "Average message count per user: %s", 
["lang_193"] = "pattern", 
["lang_194"] = "action", 
["lang_195"] = "Successfully changed configuration variable: %s = %s", 
["lang_196"] = "Configuration variable %s can only be set to: %s", 
["lang_197"] = "or", 
["lang_198"] = "Configuration variable %s must be a number.", 
["lang_199"] = "to", 
["lang_200"] = "Unknown configuration variable: %s", 
["lang_201"] = "%s with IP %s and class %s sent following spam message exception in offline message: %s", 
["lang_202"] = "%s with IP %s and class %s had bad luck sending following spam message in offline message: %s", 
["lang_203"] = "%s was dropped after spam message.", 
["lang_204"] = "%s was kicked after spam message.", 
["lang_205"] = "%s was temporary banned for %s after spam message.", 
["lang_206"] = "%s with IP %s and class %s sent following spam message exception in PM: %s", 
["lang_207"] = "%s with IP %s and class %s had bad luck sending following spam message in PM: %s", 
["lang_208"] = "%s was temporary banned for %s: <%s> %s", 
["lang_209"] = "number", 
["lang_210"] = "nick", 
["lang_211"] = "message", 
["lang_212"] = "type", 
["lang_213"] = "value", 
["lang_214"] = "variable", 
["lang_215"] = "selfspam", 
["lang_216"] = "%s is happy and thinks his message was sent.", 
["lang_217"] = "%s changed configuration variable: %s = %s", 
["lang_218"] = "%s had bad luck kicking offline user: %s", 
["lang_219"] = "%s had bad luck redirecting offline user: %s", 
["lang_220"] = "%s with IP %s and class %s had bad luck redirecting %s to %s: %s", 
["lang_221"] = "This operation might take some time depending on how much is going to be removed. Please be patient.", 
["lang_222"] = "%s deleted stats entries older than %s days."

}

command_ledohelp = "ledohelp"
command_ledover = "ledover"
command_ledoconf = "ledoconf"
command_ledoset = "ledoset"
command_ledosql = "ledosql"

mincommandclass = 5
minusrcommandclass = 0
commandstopm = 1
addledobot = 1

ledobotnick = "Ledokol"
feednick = ledobotnick
botnick = "VerliHub"
opchatnick = "OPChat"

optrig = "!"
ustrig = "+"

-- ledokol own stuff end

-- other hub commands begin

command_set = "set"
command_equals = "="
command_drop = "drop"
command_kick = "kick"
command_ban = "ban"
command_unban = "unban"
command_regpass = "regpass"
command_regpasswd = "regpasswd"
command_regme = "regme"
command_passwd = "passwd"
command_report = "report"
command_me = "me"
command_msgsend = "msgsend"

-- other hub commands end

-- load functions begin

function Main ()
createtables ()
--altertables ()
createsettings ()
loadsettings ()

optrig = getconfig ("cmd_start_op")
ustrig = getconfig ("cmd_start_user")
botnick = getconfig ("hub_security")
opchatnick = getconfig ("opchat_name")

if addledobot == 1 then
ledobotadd ()

if notifytoledobot == 0 then
feednick = opchatnick
else
feednick = ledobotnick
end

else
feednick = opchatnick
end

return 1
end

function UnLoad ()
if addledobot == 1 then
ledobotdel ()
end

return 1
end

-- load functions end

-- verlihub functions begin

function VH_OnOperatorCommand (nick, data)
oprankaccept (nick)

-- notify operator commands begin

if notifycom == 1 then
if (string.find (data, "^"..optrig..command_regpasswd.." %S+ .*$")) or (string.find (data, "^"..optrig..command_regpass.." %S+ .*$")) then
-- don't notify when password is specified

elseif (string.find (data, "^"..optrig..command_topic.."$")) or (string.find (data, "^"..optrig..command_topic.." .+$")) then
-- do nothing, we'll see it in main chat anyway

elseif string.find (data, "^"..optrig..command_drop.." %S+$") then
-- do nothing, we'll see it in main or operators chat anyway

elseif string.find (data, "^"..optrig..command_set.." %S+ .*$") then

if notifyconfig == 0 then
donotifycommand (nick, data)
end

elseif string.find (data, "^"..optrig..command_equals.." %S+ .*$") then

if notifyconfig == 0 then
donotifycommand (nick, data)
end

elseif string.find (data, "^"..optrig..command_ledoset.." %S+ .+$") then

if notifyconfig == 0 then
donotifycommand (nick, data)
end

elseif string.find (data, "^"..optrig..command_kick.." %S+ .*$") then

if notifykick == 0 then
donotifycommand (nick, data)
end

elseif string.find (data, "^"..optrig..command_ban.."%S* %S+ .*$") then

if notifyban == 0 then
donotifycommand (nick, data)
end

elseif string.find (data, "^"..optrig..command_unban.."%S* %S+ .*$") then

if notifyban == 0 then
donotifycommand (nick, data)
end

elseif string.find (data, "^"..optrig..command_histclean.."$") then

if notifyledoact == 0 then
donotifycommand (nick, data)
end

elseif string.find (data, "^"..optrig..command_offclean.."$") then

if notifyledoact == 0 then
donotifycommand (nick, data)
end

elseif string.find (data, "^"..optrig..command_cleanup.." %S+ %d+$") then

if notifyledoact == 0 then
donotifycommand (nick, data)
end

elseif string.find (data, "^"..optrig..command_say.." %S* .*$") then

if notifysay == 0 then
donotifycommand (nick, data)
end

else
donotifycommand (nick, data)
end
end

-- notify operator commands end

-- ledokol commands begin

if getclass (nick) >= mincommandclass then
if string.find (data, "^"..optrig..command_antiadd.." .+$") then
addantientry (nick, string.sub (data, string.len (optrig..command_antiadd) + 2, -1))

return 0

elseif string.find (data, "^"..optrig..command_antimod.." .+$") then
modantientry (nick, string.sub (data, string.len (optrig..command_antimod) + 2, -1))

return 0

elseif string.find (data, "^"..optrig..command_antidel.." .+$") then
delantientry (nick, string.sub (data, string.len (optrig..command_antidel) + 2, -1))

return 0

elseif string.find (data, "^"..optrig..command_antilist.."$") then
listantientry (nick)

return 0

elseif string.find (data, "^"..optrig..command_exadd.." .+$") then
addexentry (nick, string.sub (data, string.len (optrig..command_exadd) + 2, -1))

return 0

elseif string.find (data, "^"..optrig..command_exdel.." .+$") then
delexentry (nick, string.sub (data, string.len (optrig..command_exdel) + 2, -1))

return 0

elseif string.find (data, "^"..optrig..command_exlist.."$") then
listexentry (nick)

return 0

elseif (string.find (data, "^"..optrig..command_reglist.." %d+ %d+x%d+$")) or (string.find (data, "^"..optrig..command_reglist.." %-%d+ %d+x%d+$")) then
sendreglist (nick, string.sub (data, string.len (optrig..command_reglist) + 2, -1))

return 0

elseif string.find (data, "^"..optrig..command_chatrandel.." %S+$") then
delchatrank (nick, string.sub (data, string.len (optrig..command_chatrandel) + 2, -1))

return 0

elseif string.find (data, "^"..optrig..command_oprandel.." %S+$") then
deloprank (nick, string.sub (data, string.len (optrig..command_oprandel) + 2, -1))

return 0

elseif string.find (data, "^"..optrig..command_say.." %S* .*$") then
sendsay (nick, string.sub (data, string.len (optrig..command_say) + 2, -1))

return 0

elseif string.find (data, "^"..optrig..command_ledohelp.."$") then
sendhelp (nick)

return 0

elseif string.find (data, "^"..optrig..command_ledover.."$") then
upgradecheck (nick)

return 0

elseif string.find (data, "^"..optrig..command_ledoset.." %S+ .+$") then -- in future when i want to allow empty configs; .." %S+ .*$"
donotifyconfig (nick, string.sub (data, string.len (optrig..command_ledoset) + 2, -1)) -- this goes first, otherwise we wont see it at all
setledoconf (nick, string.sub (data, string.len (optrig..command_ledoset) + 2, -1))

return 0

elseif string.find (data, "^"..optrig..command_ledoconf.."$") then
showledoconf (nick)

return 0

elseif string.find (data, "^"..optrig..command_cleanup.." %S+ %d+$") then
cleanuptable (nick, string.sub (data, string.len (optrig..command_cleanup) + 2, -1))

return 0

elseif string.find (data, "^"..optrig..command_myinfadd.." %S+ .+$") then
addmyinfoentry (nick, string.sub (data, string.len (optrig..command_myinfadd) + 2, -1))

return 0

elseif string.find (data, "^"..optrig..command_myinfdel.." %S+ .+$") then
delmyinfoentry (nick, string.sub (data, string.len (optrig..command_myinfdel) + 2, -1))

return 0

elseif string.find (data, "^"..optrig..command_myinflist.." %S+$") then
listmyinfoentry (nick, string.sub (data, string.len (optrig..command_myinflist) + 2, -1))

return 0

elseif string.find (data, "^"..optrig..command_offlist.."$") then
listoffline (nick)

return 0

elseif string.find (data, "^"..optrig..command_offdel.." .+$") then
deloffline (nick, string.sub (data, string.len (optrig..command_offdel) + 2, -1))

return 0

elseif string.find (data, "^"..optrig..command_offclean.."$") then
cleanoffline (nick)

return 0

elseif string.find (data, "^"..optrig..command_histclean.."$") then
cleanhistory (nick)

return 0

elseif string.find (data, "^"..optrig..command_ophist.." %d+$") then
sendophistory (nick, string.sub (data, string.len (optrig..command_ophist) + 2, -1))

return 0

elseif string.find (data, "^"..optrig..command_ledosql.." .+$") then -- don't use it unless you know what it does, you can fuck up your hub in one step
res, err = VH:SQLQuery (string.sub (data, string.len (optrig..command_ledosql) + 2, -1))
res, err = VH:SQLFree ()

return 0
end
end

-- ledokol commands end

-- non ledokol commands begin

if (string.find (data, "^"..optrig..command_topic.."$")) or (string.find (data, "^"..optrig..command_topic.." .+$")) then
savetopic (nick, string.sub (data, string.len (optrig..command_topic) + 2, -1))

elseif string.find (data, "^"..optrig..command_topic.." $") then -- don't allow to set empty topic
maintouser (nick, gettranslation ("lang_055"))

return 0

elseif string.find (data, "^"..optrig..command_kick.." %S+ .*$") then
donotifykick (nick, data)

elseif string.find (data, "^"..optrig..command_ban.."%S* %S+ .*$") then
donotifyban (nick, data)

elseif string.find (data, "^"..optrig..command_unban.."%S* %S+ .*$") then
donotifyunban (nick, data)

elseif string.find (data, "^"..optrig..command_set.." %S+ .*$") then
donotifyconfig (nick, string.sub (data, string.len (optrig..command_set) + 2, -1))

elseif string.find (data, "^"..optrig..command_equals.." %S+ .*$") then
donotifyconfig (nick, string.sub (data, string.len (optrig..command_equals) + 2, -1))
end

-- non ledokol commands end

return 1
end

function VH_OnUserCommand (nick, data)
disable_usr_cmds = getconfig ("disable_usr_cmds")

if tonumber (disable_usr_cmds) then
disable_usr_cmds = tonumber (disable_usr_cmds)
else
disable_usr_cmds = nil
end

if (disable_usr_cmds == 0) or (disable_usr_cmds == nil) then

if string.find (data, "^"..ustrig..command_me.." .*$") then -- scan for spam on +me command
retval = 1
disable_me_cmd = getconfig ("disable_me_cmd")

if tonumber (disable_me_cmd) then
disable_me_cmd = tonumber (disable_me_cmd)
else
disable_me_cmd = nil
end

if (disable_me_cmd == 0) or (disable_me_cmd == nil) then -- scan only of command is enabled, we don't want to waste resources
retval = scanmctext (nick, string.sub (data, string.len (ustrig..command_me) + 2, -1))
end

return retval
end

-- notify user commands begin

if notifycom == 1 then
if (string.find (data, "^"..ustrig..command_regme.."$")) or (string.find (data, "^"..ustrig..command_regme.." .*$")) then
-- do nothing, if it's enabled we'll see the notification

elseif string.find (data, "^"..ustrig..command_me.."$") then
-- do nothing, if it's enabled we'll see it in main chat

elseif string.find (data, "^"..ustrig..command_passwd.." .*$") then
-- do nothing, we don't want to see the password

elseif string.find (data, "^"..ustrig..command_report.." .+$") then
-- do nothing, if it's enabled we'll see the notification

elseif string.find (data, "^"..ustrig..command_offmsg.." %S+ .+$") then
-- do nothing

elseif string.find (data, "^"..ustrig..command_msgsend.." .+$") then
-- offline messenger plugin command, do nothing

else
donotifycommand (nick, data)
end
end

-- notify user commands end

-- ledokol commands begin

if getclass (nick) >= minusrcommandclass then
if string.find (data, "^"..ustrig..command_showtopic.."$") then
sendtopic (nick)

return 0

elseif string.find (data, "^"..ustrig..command_mychatrank.."$") then
chatranksendown (nick)

return 0

elseif string.find (data, "^"..ustrig..command_myoprank.."$") then
opranksendown (nick)

return 0

elseif string.find (data, "^"..ustrig..command_chatranks.."$") then
chatranksendall (nick)

return 0

elseif string.find (data, "^"..ustrig..command_opranks.."$") then
opranksendall (nick)

return 0

elseif string.find (data, "^"..ustrig..command_remind.."$") then
sendreminder (nick)

return 0

elseif string.find (data, "^"..ustrig..command_offmsg.." %S+ .+$") then
sendoffmsg (nick, string.sub (data, string.len (ustrig..command_offmsg) + 2, -1))

return 0

elseif string.find (data, "^"..ustrig..command_history.." %d+$") then
sendmchistory (nick, string.sub (data, string.len (ustrig..command_history) + 2, -1))

return 0
end
end

-- ledokol commands end

end

return 1
end

function VH_OnUserLogin (nick)
if micheck == 1 then
cls = getclass (nick)

if (cls < scanbelowclass) and (cls >= 0) then -- don't check pingers
res, myinfo = VH:GetMyINFO (nick)
res = 1 -- temporary bug fix

if res then
desc, tag, conn, email, share = parsemyinfo (nick, myinfo)

if checknick (nick) == 0 then
if checkdesc (nick, desc) == 0 then
if checktag (nick, tag) == 0 then
if checkconn (nick, conn) == 0 then
if checkemail (nick, email) == 0 then
if checkshare (nick, share) == 0 then
checkclone (nick, share)
end
end
end
end
end
end
end
end
end

if getstatus (nick) == 1 then
autosendoffmsg (nick)
end

return 1
end

function VH_OnTimer ()
if remrunning == 1 then
remseconds = remseconds + 1

if remseconds >= reminterval then
remseconds = 0

if addledobot == 1 then
sendfrom = ledobotnick
else
sendfrom = botnick
end

if rempmmode == 0 then
VH:SendDataToAll ("<"..sendfrom.."> "..remtext.."|", remminclass, remmaxclass)
else
VH:SendPMToAll (remtext, sendfrom, remminclass, remmaxclass)
end

if (histrunning == 1) and (histbotmsg == 1) then
addmchistoryline (sendfrom, remtext)
end
end
end

return 1
end

function VH_OnUnknownMsg (nick, data)
donotifyunk (nick, data)

return 1
end

function VH_OnParsedMsgAny (nick, data)
if string.find (data, "^%$Kick %S+$") then
oprankaccept (nick)
donotifyprotokick (nick, string.sub (data, string.len ("$Kick") + 2, -1))

elseif string.find (data, "^%$OpForceMove %$Who:%S+%$Where:.*%$Msg:.*$") then
oprankaccept (nick)
donotifyredir (nick, string.sub (data, string.len ("$OpForceMove") + 2, -1))
end

return 1
end

function VH_OnOperatorDrops (op, nick)
oprankaccept (op)

return 1
end

function VH_OnParsedMsgPM (from, data, to)
retval = 1

if to == opchatnick then
addophistoryline (from, data)
elseif to == ledobotnick then
if addledobot == 1 then
VH:SendDataToUser ("$To: "..from.." From: "..ledobotnick.." $<"..ledobotnick.."> "..gettranslation ("lang_009").."|", from)
end

else
retval = scanpmtext (from, to, data)
end

return retval
end

function VH_OnParsedMsgChat (nick, data)
retval = 1
mainchat_class = getconfig ("mainchat_class")

if tonumber (mainchat_class) then
mainchat_class = tonumber (mainchat_class)
else
mainchat_class = 0
end

if getclass (nick) >= mainchat_class then
retval = scanmctext (nick, data)
end

if retval == 1 then
chatrankaccept (nick)
addmchistoryline (nick, data)
end

return retval
end

-- verlihub functions end

-- upgrade check functions begin

function upgradecheck (nick)
os.execute ("wget -t 1 -T 5 -q -O "..ledoverdir..ledoverfile.." http://"..ledoverdns.."/"..ledoverfile)
verfile = io.open (ledoverdir..ledoverfile)

if verfile then
line = ""
line = verfile:read ()
bver = string.gsub (line, "%.", "")
verfile:close ()
os.execute ("rm "..ledoverdir..ledoverfile)

if tonumber (bver) then
bver = tonumber (bver)
aver = string.gsub (ledover, "%.", "")
aver = tonumber (aver)

if bver > aver then
maintouser (nick, string.format (gettranslation ("lang_024"), line, "http://"..ledoverdns.."/ledokol.php?page=download"))
else
maintouser (nick, gettranslation ("lang_025"))
end

else
maintouser (nick, gettranslation ("lang_019"))
end

else
maintouser (nick, gettranslation ("lang_016"))
end

return 0
end

-- upgrade check functions end

-- history functions begin

function cleanhistory (nick)
res, arows = VH:SQLQuery ("select `id` from `script_ledokol_mchistory`")

if res then
if arows > 0 then
res, err = VH:SQLQuery ("truncate table `script_ledokol_mchistory`")
maintouser (nick, string.format (gettranslation ("lang_011"), arows))
else
maintouser (nick, gettranslation ("lang_012"))
end
end

res, brows = VH:SQLQuery ("select `id` from `script_ledokol_ophistory`")

if res then
if brows > 0 then
res, err = VH:SQLQuery ("truncate table `script_ledokol_ophistory`")
maintouser (nick, string.format (gettranslation ("lang_013"), brows))
else
maintouser (nick, gettranslation ("lang_014"))
end
end

if (arows > 0) or (brows > 0) then
if notifyledoact == 1 then
cmsg = string.format (gettranslation ("lang_015"), nick)
VH:SendPMToAll (cmsg, feednick, classnotiledoact, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end
end

res, err = VH:SQLFree ()

return 0
end

function sendmchistory (nick, lines)
if histrunning == 1 then
lines = tonumber (lines)

if lines >= histlimit then
lines = histlimit
elseif lines <= 1 then
lines = 1
end

res, rows = VH:SQLQuery ("select `nick`, `date`, `message` from `script_ledokol_mchistory` order by `date` desc limit "..lines)

if res then
if rows > 0 then
aentry = ""

for x = 0, rows - 1 do
res, user, adate, msg = VH:SQLFetch (x)
aentry = " "..adate..": <"..user.."> "..msg.."\r\n"..aentry
end

textlines = string.format (gettranslation ("lang_017"), rows)..":\r\n\r\n"..aentry

if commandstopm == 0 then
maintouser (nick, textlines)
else
pmfrombot (nick, textlines)
end

else
maintouser (nick, gettranslation ("lang_018"))
end
end

res, err = VH:SQLFree ()
else
maintouser (nick, gettranslation ("lang_020"))
end

return 0
end

function sendophistory (nick, lines)
if histrunning == 1 then
lines = tonumber (lines)

if lines >= histlimit then
lines = histlimit
elseif lines <= 1 then
lines = 1
end

res, rows = VH:SQLQuery ("select `nick`, `date`, `message` from `script_ledokol_ophistory` order by `date` desc limit "..lines)

if res then
if rows > 0 then
aentry = ""

for x = 0, rows - 1 do
res, user, adate, msg = VH:SQLFetch (x)
aentry = " "..adate..": <"..user.."> "..msg.."\r\n"..aentry
end

textlines = string.format (gettranslation ("lang_021"), rows)..":\r\n\r\n"..aentry

if commandstopm == 0 then
maintouser (nick, textlines)
else
pmfrombot (nick, textlines)
end

else
maintouser (nick, gettranslation ("lang_022"))
end
end

res, err = VH:SQLFree ()
else
maintouser (nick, gettranslation ("lang_023"))
end

return 0
end

function addmchistoryline (nick, line)
if histrunning == 1 then
res, rows = VH:SQLQuery ("select `date` from `script_ledokol_mchistory` order by `date` asc")

if res then
ndate = os.date ("%Y-%m-%d %H:%M:%S")
nick = repsqlchars (nick)
line = repsqlchars (line)

if rows > 0 then
if rows >= histlimit then
res, adate = VH:SQLFetch (0)
res, err = VH:SQLQuery ("update `script_ledokol_mchistory` set `nick`='"..nick.."', `date`='"..ndate.."', `message`='"..line.."' where `date`='"..adate.."' limit 1")
else
res, err = VH:SQLQuery ("insert into `script_ledokol_mchistory` (`nick`, `date`, `message`) values ('"..nick.."', '"..ndate.."', '"..line.."')")
end

else
res, err = VH:SQLQuery ("insert into `script_ledokol_mchistory` (`nick`, `date`, `message`) values ('"..nick.."', '"..ndate.."', '"..line.."')")
end
end

res, err = VH:SQLFree ()
end

return 0
end

function addophistoryline (nick, line)
if histrunning == 1 then
if string.sub (line, 1, 1) == "+" then
-- skip a chatroom +command
else
res, rows = VH:SQLQuery ("select `date` from `script_ledokol_ophistory` order by `date` asc")

if res then
ndate = os.date ("%Y-%m-%d %H:%M:%S")
nick = repsqlchars (nick)
line = repsqlchars (line)

if rows > 0 then
if rows >= histlimit then
res, adate = VH:SQLFetch (0)
res, err = VH:SQLQuery ("update `script_ledokol_ophistory` set `nick`='"..nick.."', `date`='"..ndate.."', `message`='"..line.."' where `date`='"..adate.."' limit 1")
else
res, err = VH:SQLQuery ("insert into `script_ledokol_ophistory` (`nick`, `date`, `message`) values ('"..nick.."', '"..ndate.."', '"..line.."')")
end

else
res, err = VH:SQLQuery ("insert into `script_ledokol_ophistory` (`nick`, `date`, `message`) values ('"..nick.."', '"..ndate.."', '"..line.."')")
end
end

res, err = VH:SQLFree ()
end
end

return 0
end

-- history functions end

-- offline functions begin

function sendoffmsg (from, line)
if offrunning == 1 then
_, space = string.find (line, string.char (32))
to = string.sub (line, 1, space - 1)
msg = string.sub (line, space + 1, -1)

if string.lower (to) == string.lower (from) then
maintouser (from, gettranslation ("lang_026"))
else

if scanofftext (from, msg, to) == 1 then
if getstatus (to) == 1 then
offlinepm (from, to, msg)
maintouser (from, string.format (gettranslation ("lang_027"), to))
else
uip = getip (from)
res, err = VH:SQLQuery ("insert into `script_ledokol_offline` (`from`, `ip`, `to`, `date`, `message`) values ('"..repsqlchars (from).."', '"..uip.."', '"..repsqlchars (to).."', '"..os.date ("%Y-%m-%d %H:%M:%S").."', '"..repsqlchars (msg).."')")
maintouser (from, string.format (gettranslation ("lang_028"), to))

if notifyoff == 1 then
cmsg = string.format (gettranslation ("lang_029"), from, uip)
VH:SendPMToAll (cmsg, feednick, classnotioff, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end
end
end
end

else
maintouser (from, gettranslation ("lang_030"))
end

return 0
end

function autosendoffmsg (to)
if offrunning == 1 then
user = repsqlchars (to)
res, rows = VH:SQLQuery ("select `from`, `date`, `message` from `script_ledokol_offline` where `to`='"..user.."' order by `date` asc, `from` asc")

if (res) and (rows > 0) then
for x = 0, rows - 1 do
res, from, adate, msg = VH:SQLFetch (x)

if getstatus (from) == 0 then
sts = gettranslation ("lang_031")
else
sts = gettranslation ("lang_032")
end

offlinepm (from, to, string.format (gettranslation ("lang_033"), adate)..":\r\n\r\n"..msg.."\r\n\r\n"..gettranslation ("lang_034")..": "..sts.."\r\n")
end

if notifyoff == 1 then
cmsg = string.format (gettranslation ("lang_035"), to, getip (to))
VH:SendPMToAll (cmsg, feednick, classnotioff, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end

res, err = VH:SQLQuery ("delete from `script_ledokol_offline` where `to`='"..user.."'")
end

res, err = VH:SQLFree ()
end

return 0
end

function listoffline (nick)
res, rows = VH:SQLQuery ("select `from`, `ip`, `date` from `script_ledokol_offline` order by `date` asc, `from` asc")

if res then
if rows > 0 then
anentry = ""

for x = 0, rows - 1 do
res, from, ip, adate = VH:SQLFetch (x)

if x == 0 then
len = string.len (rows)
end

numb = x + 1
anentry = anentry.." "..inleadingzeroes (len, numb)..numb..". <"..ip.."> <"..from.."> "..adate.."\r\n"
end

textlines = gettranslation ("lang_036")..":\r\n\r\n"..anentry

if commandstopm == 0 then
maintouser (nick, textlines)
else
pmfrombot (nick, textlines)
end

else
maintouser (nick, gettranslation ("lang_037"))
end
end

res, err = VH:SQLFree ()

return 0
end

function deloffline (nick, adate)
res, rows = VH:SQLQuery ("select `date` from `script_ledokol_offline`")

if res then
if rows > 0 then
tentry = ""

for x = 0, rows - 1 do
res, zdate = VH:SQLFetch (x)

-- strange, can't find "2007-05-05" in "2007-05-05 01:02:03", lua bug?
if string.find (reprexpchars (zdate), reprexpchars (adate)) then
tentry = tentry..zdate.."$$"
end
end

else
maintouser (nick, gettranslation ("lang_037"))
res, err = VH:SQLFree ()

return 0
end
end

num = 0

for xdate in string.gfind (tentry, "([^$]+)%$%$") do
res, err = VH:SQLQuery ("delete from `script_ledokol_offline` where `date`='"..xdate.."'")
num = num + 1
end

if num >= 1 then
maintouser (nick, string.format (gettranslation ("lang_038"), num))
else
maintouser (nick, string.format (gettranslation ("lang_039"), adate))
end

res, err = VH:SQLFree ()

return 0
end

function cleanoffline (nick)
res, rows = VH:SQLQuery ("select `id` from `script_ledokol_offline`")

if res then
if rows > 0 then
res, err = VH:SQLQuery ("truncate table `script_ledokol_offline`")
maintouser (nick, string.format (gettranslation ("lang_038"), rows))

if notifyledoact == 1 then
cmsg = string.format (gettranslation ("lang_040"), nick)
VH:SendPMToAll (cmsg, feednick, classnotiledoact, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end

else
maintouser (nick, gettranslation ("lang_041"))
end
end

res, err = VH:SQLFree ()

return 0
end

-- offline functions end

-- reminder functions begin

function sendreminder (nick)
usrclass = getclass (nick)

if (usrclass >= remminclass) and (usrclass <= remmaxclass) then
if remrunning == 0 then
maintouser (nick, gettranslation ("lang_042"))
else
maintouser (nick, remtext)
end

else
maintouser (nick, gettranslation ("lang_154"))
end

return 0
end

-- reminder functions end

-- myinfo functions begin

function checknick (nick)
if michnick == 1 then
res, rows = VH:SQLQuery ("select `nick`, `occured` from `script_ledokol_nicks` order by `occured` desc")

if (res) and (rows > 0) then
lowtxt = string.lower (nick)

for x = 0, rows - 1 do
res, entry, occured = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
occured = occured + 1
res, err = VH:SQLQuery ("update `script_ledokol_nicks` set `occured`='"..occured.."' where `nick`='"..repsqlchars (entry).."' limit 1")
ip = getip (nick)
res, rows = VH:SQLQuery ("select `exception`, `occured` from `script_ledokol_myinfoexceptions`")

if (res) and (rows > 0) then
for x = 0, rows - 1 do
res, entry, occured = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
occured = occured + 1
res, err = VH:SQLQuery ("update `script_ledokol_myinfoexceptions` set `occured`='"..occured.."' where `exception`='"..repsqlchars (entry).."' limit 1")

if notifymyinfex == 1 then
cmsg = string.format (gettranslation ("lang_043"), nick, ip, nick)
VH:SendPMToAll (cmsg, feednick, classnotimyinfex, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end

res, err = VH:SQLFree ()

return 0
end
end
end

if addledobot == 1 then
sendfrom = ledobotnick
else
sendfrom = botnick
end

res, err = VH:KickUser (sendfrom, nick, string.gsub (minickmessage, "%*", nick).." ledo_ban_"..mitbantime)

if notifymyinf == 1 then
cmsg = string.format (gettranslation ("lang_044"), nick, ip, mitbantime, nick)
VH:SendPMToAll (cmsg, feednick, classnotimyinf, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end

res, err = VH:SQLFree ()

return 1
end
end
end

res, err = VH:SQLFree ()
end

return 0
end

function checkdesc (nick, desc)
if michdesc == 1 then
res, rows = VH:SQLQuery ("select `description`, `occured` from `script_ledokol_descriptions` order by `occured` desc")

if (res) and (rows > 0) then
lowtxt = string.lower (desc)

for x = 0, rows - 1 do
res, entry, occured = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
occured = occured + 1
res, err = VH:SQLQuery ("update `script_ledokol_descriptions` set `occured`='"..occured.."' where `description`='"..repsqlchars (entry).."' limit 1")
ip = getip (nick)
res, rows = VH:SQLQuery ("select `exception`, `occured` from `script_ledokol_myinfoexceptions`")

if (res) and (rows > 0) then
for x = 0, rows - 1 do
res, entry, occured = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
occured = occured + 1
res, err = VH:SQLQuery ("update `script_ledokol_myinfoexceptions` set `occured`='"..occured.."' where `exception`='"..repsqlchars (entry).."' limit 1")

if notifymyinfex == 1 then
cmsg = string.format (gettranslation ("lang_045"), nick, ip, desc)
VH:SendPMToAll (cmsg, feednick, classnotimyinfex, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end

res, err = VH:SQLFree ()

return 0
end
end
end

if addledobot == 1 then
sendfrom = ledobotnick
else
sendfrom = botnick
end

res, err = VH:KickUser (sendfrom, nick, string.gsub (midescmessage, "%*", desc).." ledo_ban_"..mitbantime)

if notifymyinf == 1 then
cmsg = string.format (gettranslation ("lang_046"), nick, ip, mitbantime, desc)
VH:SendPMToAll (cmsg, feednick, classnotimyinf, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end

res, err = VH:SQLFree ()

return 1
end
end
end

res, err = VH:SQLFree ()
end

return 0
end

function checktag (nick, tag)
if michtag == 1 then
res, rows = VH:SQLQuery ("select `tag`, `occured` from `script_ledokol_tags` order by `occured` desc")

if (res) and (rows > 0) then
lowtxt = string.lower (tag)

for x = 0, rows - 1 do
res, entry, occured = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
occured = occured + 1
res, err = VH:SQLQuery ("update `script_ledokol_tags` set `occured`='"..occured.."' where `tag`='"..repsqlchars (entry).."' limit 1")
ip = getip (nick)
res, rows = VH:SQLQuery ("select `exception`, `occured` from `script_ledokol_myinfoexceptions`")

if (res) and (rows > 0) then
for x = 0, rows - 1 do
res, entry, occured = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
occured = occured + 1
res, err = VH:SQLQuery ("update `script_ledokol_myinfoexceptions` set `occured`='"..occured.."' where `exception`='"..(entry).."' limit 1")

if notifymyinfex == 1 then
cmsg = string.format (gettranslation ("lang_047"), nick, ip, tag)
VH:SendPMToAll (cmsg, feednick, classnotimyinfex, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end

res, err = VH:SQLFree ()

return 0
end
end
end

if addledobot == 1 then
sendfrom = ledobotnick
else
sendfrom = botnick
end

res, err = VH:KickUser (sendfrom, nick, string.gsub (mitagmessage, "%*", tag).." ledo_ban_"..mitbantime)

if notifymyinf == 1 then
cmsg = string.format (gettranslation ("lang_048"), nick, ip, mitbantime, tag)
VH:SendPMToAll (cmsg, feednick, classnotimyinf, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end

res, err = VH:SQLFree ()

return 1
end
end
end

res, err = VH:SQLFree ()
end

return 0
end

function checkconn (nick, conn)
if michconn == 1 then
res, rows = VH:SQLQuery ("select `connection`, `occured` from `script_ledokol_connections` order by `occured` desc")

if (res) and (rows > 0) then
lowtxt = string.lower (conn)

for x = 0, rows - 1 do
res, entry, occured = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
occured = occured + 1
res, err = VH:SQLQuery ("update `script_ledokol_connections` set `occured`='"..occured.."' where `connection`='"..repsqlchars (entry).."' limit 1")
ip = getip (nick)
res, rows = VH:SQLQuery ("select `exception`, `occured` from `script_ledokol_myinfoexceptions`")

if (res) and (rows > 0) then
for x = 0, rows - 1 do
res, entry, occured = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
occured = occured + 1
res, err = VH:SQLQuery ("update `script_ledokol_myinfoexceptions` set `occured`='"..occured.."' where `exception`='"..repsqlchars (entry).."' limit 1")

if notifymyinfex == 1 then
cmsg = string.format (gettranslation ("lang_049"), nick, ip, conn)
VH:SendPMToAll (cmsg, feednick, classnotimyinfex, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end

res, err = VH:SQLFree ()

return 0
end
end
end

if addledobot == 1 then
sendfrom = ledobotnick
else
sendfrom = botnick
end

res, err = VH:KickUser (sendfrom, nick, string.gsub (miconnmessage, "%*", conn).." ledo_ban_"..mitbantime)

if notifymyinf == 1 then
cmsg = string.format (gettranslation ("lang_050"), nick, ip, mitbantime, conn)
VH:SendPMToAll (cmsg, feednick, classnotimyinf, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end

res, err = VH:SQLFree ()

return 1
end
end
end

res, err = VH:SQLFree ()
end

return 0
end

function checkemail (nick, email)
if michemail == 1 then
res, rows = VH:SQLQuery ("select `email`, `occured` from `script_ledokol_emails` order by `occured` desc")

if (res) and (rows > 0) then
lowtxt = string.lower (email)

for x = 0, rows - 1 do
res, entry, occured = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
occured = occured + 1
res, err = VH:SQLQuery ("update `script_ledokol_emails` set `occured`='"..occured.."' where `email`='"..repsqlchars (entry).."' limit 1")
ip = getip (nick)
res, rows = VH:SQLQuery ("select `exception`, `occured` from `script_ledokol_myinfoexceptions`")

if (res) and (rows > 0) then
for x = 0, rows - 1 do
res, entry, occured = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
occured = occured + 1
res, err = VH:SQLQuery ("update `script_ledokol_myinfoexceptions` set `occured`='"..occured.."' where `exception`='"..repsqlchars (entry).."' limit 1")

if notifymyinfex == 1 then
cmsg = string.format (gettranslation ("lang_051"), nick, ip, email)
VH:SendPMToAll (cmsg, feednick, classnotimyinfex, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end

res, err = VH:SQLFree ()

return 0
end
end
end

if addledobot == 1 then
sendfrom = ledobotnick
else
sendfrom = botnick
end

res, err = VH:KickUser (sendfrom, nick, string.gsub (miemailmessage, "%*", email).." ledo_ban_"..mitbantime)

if notifymyinf == 1 then
cmsg = string.format (gettranslation ("lang_052"), nick, ip, mitbantime, email)
VH:SendPMToAll (cmsg, feednick, classnotimyinf, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end

res, err = VH:SQLFree ()

return 1
end
end
end

res, err = VH:SQLFree ()
end

return 0
end

function checkshare (nick, share)
if michshare == 1 then
res, rows = VH:SQLQuery ("select `share`, `occured` from `script_ledokol_shares` order by `occured` desc")

if (res) and (rows > 0) then
for x = 0, rows - 1 do
res, entry, occured = VH:SQLFetch (x)

if string.find (share, entry) then
occured = occured + 1
res, err = VH:SQLQuery ("update `script_ledokol_shares` set `occured`='"..occured.."' where `share`='"..repsqlchars (entry).."' limit 1")
ip = getip (nick)
res, rows = VH:SQLQuery ("select `exception`, `occured` from `script_ledokol_myinfoexceptions`")

if (res) and (rows > 0) then
for x = 0, rows - 1 do
res, entry, occured = VH:SQLFetch (x)

if string.find (share, entry) then
occured = occured + 1
res, err = VH:SQLQuery ("update `script_ledokol_myinfoexceptions` set `occured`='"..occured.."' where `exception`='"..repsqlchars (entry).."' limit 1")

if notifymyinfex == 1 then
cmsg = string.format (gettranslation ("lang_053"), nick, ip, share)
VH:SendPMToAll (cmsg, feednick, classnotimyinfex, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end

res, err = VH:SQLFree ()

return 0
end
end
end

if addledobot == 1 then
sendfrom = ledobotnick
else
sendfrom = botnick
end

res, err = VH:KickUser (sendfrom, nick, string.gsub (misharemessage, "%*", share).." ledo_ban_"..mitbantime)

if notifymyinf == 1 then
cmsg = string.format (gettranslation ("lang_054"), nick, ip, mitbantime, share)
VH:SendPMToAll (cmsg, feednick, classnotimyinf, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end

res, err = VH:SQLFree ()

return 1
end
end
end

res, err = VH:SQLFree ()
end

return 0
end

function checkclone (nick, share)
if (michclone == 1) and (share ~= "0") then -- skip zero byte user
res, nicklist = VH:GetNickList ()
res = 1 -- temporary bug fix

if res then
nicklist = string.sub (nicklist, 11)

for user in string.gfind (nicklist, "([^$]+)%$%$") do
if (user ~= nick) and (getclass (user) < scanbelowclass) then -- skip user himself and if second user is protected
res, myinfo = VH:GetMyINFO (user)
res = 1 -- temporary bug fix

if res then
d, t, c, e, ushare = parsemyinfo (user, myinfo)

if ushare == share then -- exact match
if addledobot == 1 then
sendfrom = ledobotnick
else
sendfrom = botnick
end

res, err = VH:KickUser (sendfrom, nick, string.gsub (miclonemessage, "%*", user).." ledo_ban_"..mitbantime)

if notifymyinf == 1 then
cmsg = string.format (gettranslation ("lang_003"), nick, getip (nick), mitbantime, user, getip (user))
VH:SendPMToAll (cmsg, feednick, classnotimyinf, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end

return 1
end
end
end
end
end
end

return 0
end

function parsemyinfo (nick, myinfo)
num = 0

for k = 1, string.len (myinfo), 1 do
if string.sub (myinfo, k, k) == "<" then
num = num + 1
end
end

if num > 1 then
myinfo = string.gsub (myinfo, "<", ".", num - 1)
end

num = 0

for k = 1, string.len (myinfo), 1 do
if string.sub (myinfo, k, k) == ">" then
num = num + 1
end
end

if num > 1 then
myinfo = string.gsub (myinfo, ">", ".", num - 1)
end

temp = string.sub (myinfo, 15 + string.len (nick), string.len (myinfo))
desc = string.gsub (temp, "([^<]*)<?([^>]*)>?%$.%$([^%$]-)%$([^%$]-)%$([^%$]-)%$.*$?", "%1")
tag = string.gsub (temp, "([^<]*)<?([^>]*)>?%$.%$([^%$]-)%$([^%$]-)%$([^%$]-)%$.*$?", "%2")
conn = string.gsub (temp, "([^<]*)<?([^>]*)>?%$.%$([^%$]-)%$([^%$]-)%$([^%$]-)%$.*$?", "%3")
conn = string.sub (conn, 1, string.len (conn) - 1)
email = string.gsub (temp, "([^<]*)<?([^>]*)>?%$.%$([^%$]-)%$([^%$]-)%$([^%$]-)%$.*$?", "%4")
share = string.gsub (temp, "([^<]*)<?([^>]*)>?%$.%$([^%$]-)%$([^%$]-)%$([^%$]-)%$.*$?", "%5")

return desc, "<"..tag..">", conn, email, share
end

function addmyinfoentry (nick, line)
_, space = string.find (line, string.char (32))
part = string.sub (line, 1, space - 1)
item = string.sub (line, space + 1, -1)
entry = repsqlchars (item)

if part == "nick" then
res, rows = VH:SQLQuery ("select `occured` from `script_ledokol_nicks` where `nick`='"..entry.."' limit 1")

if res then
if rows > 0 then
maintouser (nick, string.format (gettranslation ("lang_056"), item))
else
res, err = VH:SQLQuery ("insert into `script_ledokol_nicks` (`nick`, `occured`) values ('"..entry.."', '0')")
maintouser (nick, string.format (gettranslation ("lang_057"), item))
end
end

elseif part == "desc" then
res, rows = VH:SQLQuery ("select `occured` from `script_ledokol_descriptions` where `description`='"..entry.."' limit 1")

if res then
if rows > 0 then
maintouser (nick, string.format (gettranslation ("lang_058"), item))
else
res, err = VH:SQLQuery ("insert into `script_ledokol_descriptions` (`description`, `occured`) values ('"..entry.."', '0')")
maintouser (nick, string.format (gettranslation ("lang_059"), item))
end
end

elseif part == "tag" then
res, rows = VH:SQLQuery ("select `occured` from `script_ledokol_tags` where `tag`='"..entry.."' limit 1")

if res then
if rows > 0 then
maintouser (nick, string.format (gettranslation ("lang_060"), item))
else
res, err = VH:SQLQuery ("insert into `script_ledokol_tags` (`tag`, `occured`) values ('"..entry.."', '0')")
maintouser (nick, string.format (gettranslation ("lang_061"), item))
end
end

elseif part == "conn" then
res, rows = VH:SQLQuery ("select `occured` from `script_ledokol_connections` where `connection`='"..entry.."' limit 1")

if res then
if rows > 0 then
maintouser (nick, string.format (gettranslation ("lang_062"), item))
else
res, err = VH:SQLQuery ("insert into `script_ledokol_connections` (`connection`, `occured`) values ('"..entry.."', '0')")
maintouser (nick, string.format (gettranslation ("lang_063"), item))
end
end

elseif part == "email" then
res, rows = VH:SQLQuery ("select `occured` from `script_ledokol_emails` where `email`='"..entry.."' limit 1")

if res then
if rows > 0 then
maintouser (nick, string.format (gettranslation ("lang_064"), item))
else
res, err = VH:SQLQuery ("insert into `script_ledokol_emails` (`email`, `occured`) values ('"..entry.."', '0')")
maintouser (nick, string.format (gettranslation ("lang_065"), item))
end
end

elseif part == "share" then
res, rows = VH:SQLQuery ("select `occured` from `script_ledokol_shares` where `share`='"..entry.."' limit 1")

if res then
if rows > 0 then
maintouser (nick, string.format (gettranslation ("lang_066"), item))
else
res, err = VH:SQLQuery ("insert into `script_ledokol_shares` (`share`, `occured`) values ('"..entry.."', '0')")
maintouser (nick, string.format (gettranslation ("lang_067"), item))
end
end

elseif part == "ex" then
res, rows = VH:SQLQuery ("select `occured` from `script_ledokol_myinfoexceptions` where `exception`='"..entry.."' limit 1")

if res then
if rows > 0 then
maintouser (nick, string.format (gettranslation ("lang_068"), item))
else
res, err = VH:SQLQuery ("insert into `script_ledokol_myinfoexceptions` (`exception`, `occured`) values ('"..entry.."', '0')")
maintouser (nick, string.format (gettranslation ("lang_069"), item))
end
end

else
maintouser (nick, string.format (gettranslation ("lang_100"), "nick, desc, tag, conn, email, share "..gettranslation ("lang_070").." ex"))
end

res, err = VH:SQLFree ()

return 0
end

function delmyinfoentry (nick, line)
_, space = string.find (line, string.char (32))
part = string.sub (line, 1, space - 1)
item = string.sub (line, space + 1, -1)
entry = repsqlchars (item)

if part == "nick" then
res, rows = VH:SQLQuery ("select `occured` from `script_ledokol_nicks` where `nick`='"..entry.."' limit 1")

if res then
if rows > 0 then
res, err = VH:SQLQuery ("delete from `script_ledokol_nicks` where `nick`='"..entry.."' limit 1")
maintouser (nick, string.format (gettranslation ("lang_071"), item))
else
maintouser (nick, string.format (gettranslation ("lang_072"), item))
end
end

elseif part == "desc" then
res, rows = VH:SQLQuery ("select `occured` from `script_ledokol_descriptions` where `description`='"..entry.."' limit 1")

if res then
if rows > 0 then
res, err = VH:SQLQuery ("delete from `script_ledokol_descriptions` where `description`='"..entry.."' limit 1")
maintouser (nick, string.format (gettranslation ("lang_073"), item))
else
maintouser (nick, string.format (gettranslation ("lang_074"), item))
end
end

elseif part == "tag" then
res, rows = VH:SQLQuery ("select `occured` from `script_ledokol_tags` where `tag`='"..entry.."' limit 1")

if res then
if rows > 0 then
res, err = VH:SQLQuery ("delete from `script_ledokol_tags` where `tag`='"..entry.."' limit 1")
maintouser (nick, string.format (gettranslation ("lang_075"), item))
else
maintouser (nick, string.format (gettranslation ("lang_076"), item))
end
end

elseif part == "conn" then
res, rows = VH:SQLQuery ("select `occured` from `script_ledokol_connections` where `connection`='"..entry.."' limit 1")

if res then
if rows > 0 then
res, err = VH:SQLQuery ("delete from `script_ledokol_connections` where `connection`='"..entry.."' limit 1")
maintouser (nick, string.format (gettranslation ("lang_077"), item))
else
maintouser (nick, string.format (gettranslation ("lang_078"), item))
end
end

elseif part == "email" then
res, rows = VH:SQLQuery ("select `occured` from `script_ledokol_emails` where `email`='"..entry.."' limit 1")

if res then
if rows > 0 then
res, err = VH:SQLQuery ("delete from `script_ledokol_emails` where `email`='"..entry.."' limit 1")
maintouser (nick, string.format (gettranslation ("lang_079"), item))
else
maintouser (nick, string.format (gettranslation ("lang_080"), item))
end
end

elseif part == "share" then
res, rows = VH:SQLQuery ("select `occured` from `script_ledokol_shares` where `share`='"..entry.."' limit 1")

if res then
if rows > 0 then
res, err = VH:SQLQuery ("delete from `script_ledokol_shares` where `share`='"..entry.."' limit 1")
maintouser (nick, string.format (gettranslation ("lang_081"), item))
else
maintouser (nick, string.format (gettranslation ("lang_082"), item))
end
end

elseif part == "ex" then
res, rows = VH:SQLQuery ("select `occured` from `script_ledokol_myinfoexceptions` where `exception`='"..entry.."' limit 1")

if res then
if rows > 0 then
res, err = VH:SQLQuery ("delete from `script_ledokol_myinfoexceptions` where `exception`='"..entry.."' limit 1")
maintouser (nick, string.format (gettranslation ("lang_083"), item))
else
maintouser (nick, string.format (gettranslation ("lang_084"), item))
end
end

else
maintouser (nick, string.format (gettranslation ("lang_100"), "nick, desc, tag, conn, email, share "..gettranslation ("lang_070").." ex"))
end

res, err = VH:SQLFree ()

return 0
end

function listmyinfoentry (nick, part)
if part == "nick" then
res, rows = VH:SQLQuery ("select `nick`, `occured` from `script_ledokol_nicks` order by `occured` desc")

if res then
if rows > 0 then
anentry = ""

for x = 0, rows - 1 do
res, entry, occured = VH:SQLFetch (x)

if x == 0 then
len = string.len (occured)
numlen = string.len (rows)
end

numb = x + 1
anentry = anentry.." "..inleadingzeroes (numlen, numb)..numb..". [O: "..inleadingzeroes (len, occured)..occured.."] "..entry.."\r\n"
end

textlines = gettranslation ("lang_085")..":\r\n\r\n"..anentry

if commandstopm == 0 then
maintouser (nick, textlines)
else
pmfrombot (nick, textlines)
end

else
maintouser (nick, gettranslation ("lang_086"))
end
end

elseif part == "desc" then
res, rows = VH:SQLQuery ("select `description`, `occured` from `script_ledokol_descriptions` order by `occured` desc")

if res then
if rows > 0 then
anentry = ""

for x = 0, rows - 1 do
res, entry, occured = VH:SQLFetch (x)

if x == 0 then
len = string.len (occured)
numlen = string.len (rows)
end

numb = x + 1
anentry = anentry.." "..inleadingzeroes (numlen, numb)..numb..". [O: "..inleadingzeroes (len, occured)..occured.."] "..entry.."\r\n"
end

textlines = gettranslation ("lang_087")..":\r\n\r\n"..anentry

if commandstopm == 0 then
maintouser (nick, textlines)
else
pmfrombot (nick, textlines)
end

else
maintouser (nick, gettranslation ("lang_088"))
end
end

elseif part == "tag" then
res, rows = VH:SQLQuery ("select `tag`, `occured` from `script_ledokol_tags` order by `occured` desc")

if res then
if rows > 0 then
anentry = ""

for x = 0, rows - 1 do
res, entry, occured = VH:SQLFetch (x)

if x == 0 then
len = string.len (occured)
numlen = string.len (rows)
end

numb = x + 1
anentry = anentry.." "..inleadingzeroes (numlen, numb)..numb..". [O: "..inleadingzeroes (len, occured)..occured.."] "..entry.."\r\n"
end

textlines = gettranslation ("lang_089")..":\r\n\r\n"..anentry

if commandstopm == 0 then
maintouser (nick, textlines)
else
pmfrombot (nick, textlines)
end

else
maintouser (nick, gettranslation ("lang_090"))
end
end

elseif part == "conn" then
res, rows = VH:SQLQuery ("select `connection`, `occured` from `script_ledokol_connections` order by `occured` desc")

if res then
if rows > 0 then
anentry = ""

for x = 0, rows - 1 do
res, entry, occured = VH:SQLFetch (x)

if x == 0 then
len = string.len (occured)
numlen = string.len (rows)
end

numb = x + 1
anentry = anentry.." "..inleadingzeroes (numlen, numb)..numb..". [O: "..inleadingzeroes (len, occured)..occured.."] "..entry.."\r\n"
end

textlines = gettranslation ("lang_091")..":\r\n\r\n"..anentry

if commandstopm == 0 then
maintouser (nick, textlines)
else
pmfrombot (nick, textlines)
end

else
maintouser (nick, gettranslation ("lang_092"))
end
end

elseif part == "email" then
res, rows = VH:SQLQuery ("select `email`, `occured` from `script_ledokol_emails` order by `occured` desc")

if res then
if rows > 0 then
anentry = ""

for x = 0, rows - 1 do
res, entry, occured = VH:SQLFetch (x)

if x == 0 then
len = string.len (occured)
numlen = string.len (rows)
end

numb = x + 1
anentry = anentry.." "..inleadingzeroes (numlen, numb)..numb..". [O: "..inleadingzeroes (len, occured)..occured.."] "..entry.."\r\n"
end

textlines = gettranslation ("lang_093")..":\r\n\r\n"..anentry

if commandstopm == 0 then
maintouser (nick, textlines)
else
pmfrombot (nick, textlines)
end

else
maintouser (nick, gettranslation ("lang_094"))
end
end

elseif part == "share" then
res, rows = VH:SQLQuery ("select `share`, `occured` from `script_ledokol_shares` order by `occured` desc")

if res then
if rows > 0 then
anentry = ""

for x = 0, rows - 1 do
res, entry, occured = VH:SQLFetch (x)

if x == 0 then
len = string.len (occured)
numlen = string.len (rows)
end

numb = x + 1
anentry = anentry.." "..inleadingzeroes (numlen, numb)..numb..". [O: "..inleadingzeroes (len, occured)..occured.."] "..entry.."\r\n"
end

textlines = gettranslation ("lang_095")..":\r\n\r\n"..anentry

if commandstopm == 0 then
maintouser (nick, textlines)
else
pmfrombot (nick, textlines)
end

else
maintouser (nick, gettranslation ("lang_096"))
end
end

elseif part == "ex" then
res, rows = VH:SQLQuery ("select `exception`, `occured` from `script_ledokol_myinfoexceptions` order by `occured` desc")

if res then
if rows > 0 then
anentry = ""

for x = 0, rows - 1 do
res, entry, occured = VH:SQLFetch (x)

if x == 0 then
len = string.len (occured)
numlen = string.len (rows)
end

numb = x + 1
anentry = anentry.." "..inleadingzeroes (numlen, numb)..numb..". [O: "..inleadingzeroes (len, occured)..occured.."] "..entry.."\r\n"
end

textlines = gettranslation ("lang_097")..":\r\n\r\n"..anentry

if commandstopm == 0 then
maintouser (nick, textlines)
else
pmfrombot (nick, textlines)
end

else
maintouser (nick, gettranslation ("lang_098"))
end
end

else
maintouser (nick, string.format (gettranslation ("lang_100"), "nick, desc, tag, conn, email, share "..gettranslation ("lang_070").." ex"))
end

res, err = VH:SQLFree ()

return 0
end

-- myinfo functions end

-- verlihub database functions begin

function cleanuptable (nick, line)
lang_099 = gettranslation ("lang_099")
lang_101 = gettranslation ("lang_101")
_, space = string.find (line, string.char (32))
ctype = string.sub (line, 1, space - 1)
cdays = string.sub (line, space + 1, -1)
seconds = tonumber (cdays) * 24 * 3600
seconds = tonumber (os.time ()) - seconds

if ctype == "kick" then
maintouser (nick, gettranslation ("lang_221"))
res, rows = VH:SQLQuery ("select `is_drop` from `kicklist` where `time`<'"..seconds.."'")

if res then
if rows > 0 then
res, err = VH:SQLQuery ("delete from `kicklist` where `time`<'"..seconds.."'")
maintouser (nick, string.format (lang_099, rows, ctype))

if notifyledoact == 1 then
cmsg = string.format (gettranslation ("lang_008"), nick, cdays)
VH:SendPMToAll (cmsg, feednick, classnotiledoact, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end

else
maintouser (nick, string.format (lang_101, ctype))
end
end

elseif ctype == "ban" then
maintouser (nick, gettranslation ("lang_221"))
res, rows = VH:SQLQuery ("select `ban_type` from `banlist` where `date_start`<'"..seconds.."'")

if res then
if rows > 0 then
res, err = VH:SQLQuery ("delete from `banlist` where `date_start`<'"..seconds.."'")
maintouser (nick, string.format (lang_099, rows, ctype))

if notifyledoact == 1 then
cmsg = string.format (gettranslation ("lang_007"), nick, cdays)
VH:SendPMToAll (cmsg, feednick, classnotiledoact, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end

else
maintouser (nick, string.format (lang_101, ctype))
end
end

elseif ctype == "unban" then
maintouser (nick, gettranslation ("lang_221"))
res, rows = VH:SQLQuery ("select `ban_type` from `unbanlist` where `date_start`<'"..seconds.."'")

if res then
if rows > 0 then
res, err = VH:SQLQuery ("delete from `unbanlist` where `date_start`<'"..seconds.."'")
maintouser (nick, string.format (lang_099, rows, ctype))

if notifyledoact == 1 then
cmsg = string.format (gettranslation ("lang_006"), nick, cdays)
VH:SendPMToAll (cmsg, feednick, classnotiledoact, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end

else
maintouser (nick, string.format (lang_101, ctype))
end
end

elseif ctype == "iplog" then
maintouser (nick, gettranslation ("lang_221"))
res, rows = VH:SQLQuery ("select `id` from `pi_iplog` where `date`<'"..seconds.."'")

if res then
if rows > 0 then
res, err = VH:SQLQuery ("delete from `pi_iplog` where `date`<'"..seconds.."'")
maintouser (nick, string.format (lang_099, rows, ctype))

if notifyledoact == 1 then
cmsg = string.format (gettranslation ("lang_005"), nick, cdays)
VH:SendPMToAll (cmsg, feednick, classnotiledoact, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end

else
maintouser (nick, string.format (lang_101, ctype))
end
end

elseif ctype == "stats" then
maintouser (nick, gettranslation ("lang_221"))
res, rows = VH:SQLQuery ("select `realtime` from `pi_stats` where `realtime`<'"..seconds.."'")

if res then
if rows > 0 then
res, err = VH:SQLQuery ("delete from `pi_stats` where `realtime`<'"..seconds.."'")
maintouser (nick, string.format (lang_099, rows, ctype))

if notifyledoact == 1 then
cmsg = string.format (gettranslation ("lang_222"), nick, cdays)
VH:SendPMToAll (cmsg, feednick, classnotiledoact, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end

else
maintouser (nick, string.format (lang_101, ctype))
end
end



else
maintouser (nick, string.format (gettranslation ("lang_100"), "kick, ban, unban, iplog "..gettranslation ("lang_070").." stats"))
end

res, err = VH:SQLFree ()

return 0
end

-- verlihub database functions end

-- rank functions begin

function oprankaccept (nick)
if enableopranks == 1 then
nick = repsqlchars (nick)
res, rows = VH:SQLQuery ("select `rank` from `script_ledokol_opranks` where `nick`='"..nick.."' limit 1")

if res then
if rows > 0 then
res, rank = VH:SQLFetch (0)
rank = rank + 1
res, err = VH:SQLQuery ("update `script_ledokol_opranks` set `rank`='"..rank.."' where `nick`='"..nick.."' limit 1")
else
res, err = VH:SQLQuery ("insert into `script_ledokol_opranks` (`nick`, `rank`) values ('"..nick.."', '1')")
end
end

res, err = VH:SQLFree ()
end

return 0
end

function chatrankaccept (nick)
if enablechatranks == 1 then
nick = repsqlchars (nick)
res, rows = VH:SQLQuery ("select `rank` from `script_ledokol_chatranks` where `nick`='"..nick.."' limit 1")

if res then
if rows > 0 then
res, rank = VH:SQLFetch (0)
rank = rank + 1
res, err = VH:SQLQuery ("update `script_ledokol_chatranks` set `rank`='"..rank.."' where `nick`='"..nick.."' limit 1")
else
res, err = VH:SQLQuery ("insert into `script_ledokol_chatranks` (`nick`, `rank`) values ('"..nick.."', '1')")
end
end

res, err = VH:SQLFree ()
end

return 0
end

function delchatrank (nick, user)
auser = repsqlchars (user)
res, rows = VH:SQLQuery ("select `rank` from `script_ledokol_chatranks` where `nick`='"..auser.."' limit 1")

if res then
if rows > 0 then
res, err = VH:SQLQuery ("delete from `script_ledokol_chatranks` where `nick`='"..auser.."' limit 1")
maintouser (nick, string.format (gettranslation ("lang_105"), user))
else
maintouser (nick, string.format (gettranslation ("lang_106"), user))
end
end

res, err = VH:SQLFree ()

return 0
end

function deloprank (nick, user)
auser = repsqlchars (user)
res, rows = VH:SQLQuery ("select `rank` from `script_ledokol_opranks` where `nick`='"..auser.."' limit 1")

if res then
if rows > 0 then
res, err = VH:SQLQuery ("delete from `script_ledokol_opranks` where `nick`='"..auser.."' limit 1")
maintouser (nick, string.format (gettranslation ("lang_107"), user))
else
maintouser (nick, string.format (gettranslation ("lang_108"), user))
end
end

res, err = VH:SQLFree ()

return 0
end

function chatranksendown (nick)
if enablechatranks == 0 then
maintouser (nick, gettranslation ("lang_109"))
else
res, rows = VH:SQLQuery ("select `rank` from `script_ledokol_chatranks` where `nick`='"..repsqlchars (nick).."' limit 1")

if res then
if rows > 0 then
res, rank = VH:SQLFetch (0)
maintouser (nick, string.format (gettranslation ("lang_110"), rank))
else
maintouser (nick, gettranslation ("lang_111"))
end
end

res, err = VH:SQLFree ()
end

return 0
end

function opranksendown (nick)
if getclass (nick) < 3 then
maintouser (nick, gettranslation ("lang_112"))
elseif enableopranks == 0 then
maintouser (nick, gettranslation ("lang_113"))
else
res, rows = VH:SQLQuery ("select `rank` from `script_ledokol_opranks` where `nick`='"..repsqlchars (nick).."' limit 1")

if res then
if rows > 0 then
res, rank = VH:SQLFetch (0)
maintouser (nick, string.format (gettranslation ("lang_114"), rank))
else
maintouser (nick, gettranslation ("lang_115"))
end
end

res, err = VH:SQLFree ()
end

return 0
end

function chatranksendall (nick)
if enablechatranks == 0 then
maintouser (nick, gettranslation ("lang_109"))
else
res, rows = VH:SQLQuery ("select `nick`, `rank` from `script_ledokol_chatranks` order by `rank` desc limit "..ranklimit)

if res then
if rows > 0 then
arank = ""

for x = 0, rows - 1 do
res, user, rank = VH:SQLFetch (x)

if x == 0 then
len = string.len (rank)
numlen = string.len (ranklimit)
end

numb = x + 1
arank = arank.." "..inleadingzeroes (numlen, numb)..numb..". [R: "..inleadingzeroes (len, rank)..rank.."] "..user.."\r\n"
end

textlines = string.format (gettranslation ("lang_116"), rows)..":\r\n\r\n"..arank

if commandstopm == 0 then
maintouser (nick, textlines)
else
pmfrombot (nick, textlines)
end

else
maintouser (nick, gettranslation ("lang_117"))
end
end

res, err = VH:SQLFree ()
end

return 0
end

function opranksendall (nick)
if enableopranks == 0 then
maintouser (nick, gettranslation ("lang_113"))
else
res, rows = VH:SQLQuery ("select `nick`, `rank` from `script_ledokol_opranks` order by `rank` desc limit "..ranklimit)

if res then
if rows > 0 then
arank = ""

for x = 0, rows - 1 do
res, user, rank = VH:SQLFetch (x)

if x == 0 then
len = string.len (rank)
numlen = string.len (ranklimit)
end

numb = x + 1
arank = arank.." "..inleadingzeroes (numlen, numb)..numb..". [R: "..inleadingzeroes (len, rank)..rank.."] "..user.."\r\n"
end

textlines = string.format (gettranslation ("lang_118"), rows)..":\r\n\r\n"..arank

if commandstopm == 0 then
maintouser (nick, textlines)
else
pmfrombot (nick, textlines)
end

else
maintouser (nick, gettranslation ("lang_119"))
end
end

res, err = VH:SQLFree ()
end

return 0
end

function countchatranks ()
res, rows = VH:SQLQuery ("select `rank` from `script_ledokol_chatranks`")
acount = 0

if (res) and (rows > 0) then
for x = 0, rows - 1 do
res, anum = VH:SQLFetch (x)
acount = acount + anum
end
end

res, err = VH:SQLFree ()

return acount
end

function countopranks ()
res, rows = VH:SQLQuery ("select `rank` from `script_ledokol_opranks`")
acount = 0

if (res) and (rows > 0) then
for x = 0, rows - 1 do
res, anum = VH:SQLFetch (x)
acount = acount + anum
end
end

res, err = VH:SQLFree ()

return acount
end

-- rank functions end

-- antispam functions begin

function addantientry (nick, item)
aaction = tonumber (string.sub (item, string.len (item), -1))
lang_120 = gettranslation ("lang_120")

if aaction == 0 then
actword = lang_120
item = string.sub (item, 1, string.len (item) - 2)

elseif aaction == 1 then
actword = gettranslation ("lang_121")
item = string.sub (item, 1, string.len (item) - 2)

elseif aaction == 2 then
actword = gettranslation ("lang_122")
item = string.sub (item, 1, string.len (item) - 2)

elseif aaction == 3 then
actword = gettranslation ("lang_123")
item = string.sub (item, 1, string.len (item) - 2)

elseif aaction == 4 then
actword = gettranslation ("lang_215")
item = string.sub (item, 1, string.len (item) - 2)

else
aaction = 0
actword = lang_120
end

entry = repsqlchars (item)
res, rows = VH:SQLQuery ("select `occured` from `script_ledokol_antispam` where `antispam`='"..entry.."' limit 1")

if res then
if rows > 0 then
maintouser (nick, string.format (gettranslation ("lang_124"), item))
else
res, err = VH:SQLQuery ("insert into `script_ledokol_antispam` (`antispam`, `occured`, `action`) values ('"..entry.."', '0', '"..aaction.."')")
maintouser (nick, string.format (gettranslation ("lang_125"), actword, item))
end
end

res, err = VH:SQLFree ()

return 0
end

function modantientry (nick, item)
aaction = tonumber (string.sub (item, string.len (item), -1))
lang_120 = gettranslation ("lang_120")
lang_121 = gettranslation ("lang_121")
lang_122 = gettranslation ("lang_122")
lang_123 = gettranslation ("lang_123")
lang_215 = gettranslation ("lang_215")

if aaction == 0 then
actword = lang_120
item = string.sub (item, 1, string.len (item) - 2)

elseif aaction == 1 then
actword = lang_121
item = string.sub (item, 1, string.len (item) - 2)

elseif aaction == 2 then
actword = lang_122
item = string.sub (item, 1, string.len (item) - 2)

elseif aaction == 3 then
actword = lang_123
item = string.sub (item, 1, string.len (item) - 2)

elseif aaction == 4 then
actword = lang_215
item = string.sub (item, 1, string.len (item) - 2)

else
aaction = 0
actword = lang_120
end

entry = repsqlchars (item)
res, rows = VH:SQLQuery ("select `action` from `script_ledokol_antispam` where `antispam`='"..entry.."' limit 1")

if res then
if rows > 0 then
res, baction = VH:SQLFetch (0)

if tonumber (baction) == 0 then
bactword = lang_120
elseif tonumber (baction) == 1 then
bactword = lang_121
elseif tonumber (baction) == 2 then
bactword = lang_122
elseif tonumber (baction) == 3 then
bactword = lang_123
elseif tonumber (baction) == 4 then
bactword = lang_215
end

if aaction == tonumber (baction) then
maintouser (nick, string.format (gettranslation ("lang_126"), item))
else
res, err = VH:SQLQuery ("update `script_ledokol_antispam` set `action`='"..aaction.."' where `antispam`='"..entry.."' limit 1")
maintouser (nick, string.format (gettranslation ("lang_127"), bactword, actword, item))
end

else
maintouser (nick, string.format (gettranslation ("lang_128"), item))
end
end

res, err = VH:SQLFree ()

return 0
end

function delantientry (nick, item)
aitem = repsqlchars (item)
res, rows = VH:SQLQuery ("select `occured` from `script_ledokol_antispam` where `antispam`='"..aitem.."' limit 1")

if res then
if rows > 0 then
res, err = VH:SQLQuery ("delete from `script_ledokol_antispam` where `antispam`='"..aitem.."' limit 1")
maintouser (nick, string.format (gettranslation ("lang_129"), item))
else
maintouser (nick, string.format (gettranslation ("lang_130"), item))
end
end

res, err = VH:SQLFree ()

return 0
end

function listantientry (nick)
res, rows = VH:SQLQuery ("select `antispam`, `occured`, `action` from `script_ledokol_antispam` order by `occured` desc")

if res then
if rows > 0 then
anentry = ""

for x = 0, rows - 1 do
res, entry, occured, aaction = VH:SQLFetch (x)

if x == 0 then
len = string.len (occured)
numlen = string.len (rows)
end

numb = x + 1
anentry = anentry.." "..inleadingzeroes (numlen, numb)..numb..". [A: "..aaction.."] [O: "..inleadingzeroes (len, occured)..occured.."] "..entry.."\r\n"
end

textlines = gettranslation ("lang_131")..":\r\n\r\n"..anentry

if commandstopm == 0 then
maintouser (nick, textlines)
else
pmfrombot (nick, textlines)
end

else
maintouser (nick, gettranslation ("lang_132"))
end
end

res, err = VH:SQLFree ()

return 0
end

function addexentry (nick, item)
entry = repsqlchars (item)
res, rows = VH:SQLQuery ("select `occured` from `script_ledokol_exceptions` where `exception`='"..entry.."' limit 1")

if res then
if rows > 0 then
maintouser (nick, string.format (gettranslation ("lang_133"), item))
else
res, err = VH:SQLQuery ("insert into `script_ledokol_exceptions` (`exception`, `occured`) values ('"..entry.."', '0')")
maintouser (nick, string.format (gettranslation ("lang_134"), item))
end
end

res, err = VH:SQLFree ()

return 0
end

function delexentry (nick, item)
aitem = repsqlchars (item)
res, rows = VH:SQLQuery ("select `occured` from `script_ledokol_exceptions` where `exception`='"..aitem.."' limit 1")

if res then
if rows > 0 then
res, err = VH:SQLQuery ("delete from `script_ledokol_exceptions` where `exception`='"..aitem.."' limit 1")
maintouser (nick, string.format (gettranslation ("lang_135"), item))
else
maintouser (nick, string.format (gettranslation ("lang_136"), item))
end
end

res, err = VH:SQLFree ()

return 0
end

function listexentry (nick)
res, rows = VH:SQLQuery ("select `exception`, `occured` from `script_ledokol_exceptions` order by `occured` desc")

if res then
if rows > 0 then
anentry = ""

for x = 0, rows - 1 do
res, entry, occured = VH:SQLFetch (x)

if x == 0 then
len = string.len (occured)
numlen = string.len (rows)
end

numb = x + 1
anentry = anentry.." "..inleadingzeroes (numlen, numb)..numb..". [O: "..inleadingzeroes (len, occured)..occured.."] "..entry.."\r\n"
end

textlines = gettranslation ("lang_137")..":\r\n\r\n"..anentry

if commandstopm == 0 then
maintouser (nick, textlines)
else
pmfrombot (nick, textlines)
end

else
maintouser (nick, gettranslation ("lang_138"))
end
end

res, err = VH:SQLFree ()

return 0
end

-- antispam functions end

-- topic functions begin

function savetopic (owner, topic)
topic_mod_class = getconfig ("topic_mod_class")

if tonumber (topic_mod_class) then
topic_mod_class = tonumber (topic_mod_class)
else
topic_mod_class = 3
end

if getclass (owner) >= topic_mod_class then
if (topic == nil) or (string.len (topic) < 1) then
topicowner = nil
topicvalue = nil
else
topicowner = owner
topicvalue = topic
end
end

return 0
end

function sendtopic (nick)
if topicvalue == nil then
maintouser (nick, gettranslation ("lang_000"))
else

if showtopicowner == 0 then
maintouser (nick, string.format (gettranslation ("lang_001"), topicvalue))
else
maintouser (nick, string.format (gettranslation ("lang_002"), topicowner, topicvalue))
end
end

return 0
end

-- topic functions end

-- reglist functions begin

function sendreglist (nick, line)
_, space = string.find (line, string.char (32))
class = string.sub (line, 1, space - 1)
offst = string.sub (line, space + 1, -1)
_, space = string.find (offst, "x")
sfrom = string.sub (offst, 1, space - 1)
hmany = string.sub (offst, space + 1, -1)
sfrom = tonumber (sfrom)
hmany = tonumber (hmany)

if hmany < 1 then
maintouser (nick, gettranslation ("lang_139"))
else
class = tonumber (class)

if (class == 10) or (class == 5) or (class == 4) or (class == 3) or (class == 2) or (class == 1) or (class == 0) or (class == -1) then
res, trows = VH:SQLQuery ("select `class` from `reglist` where `class`='"..class.."'")

if res then
if trows > 0 then
if (sfrom <= 0) or (sfrom > trows) then
maintouser (nick, string.format (gettranslation ("lang_140"), sfrom, trows, class))
else
mysfrom = sfrom - 1
res, rows = VH:SQLQuery ("select `nick`, `reg_date`, `pwd_change`, `login_last`, `enabled` from `reglist` where `class`='"..class.."' order by `login_last` desc limit "..mysfrom..", "..hmany)

if (res) and (rows > 0) then
areg = ""

for x = 0, rows - 1 do
res, user, rgdate, pwdc, lastlog, enacc = VH:SQLFetch (x)

if x == 0 then
numlen = string.len (rows)
end

numb = x + 1
areg = areg.." "..inleadingzeroes (numlen, numb)..numb..". [D: "..fromunixtime (rgdate).."] [L: "..fromunixtime (lastlog).."] [P: "..pwdc.."] [E: "..enacc.."] "..user.."\r\n"
end

textlines = string.format (gettranslation ("lang_141"), rows, trows, class, sfrom)..":\r\n\r\n"..areg

if commandstopm == 0 then
maintouser (nick, textlines)
else
pmfrombot (nick, textlines)
end
end
end

else
maintouser (nick, string.format (gettranslation ("lang_142"), class))
end
end

res, err = VH:SQLFree ()

else
maintouser (nick, string.format (gettranslation ("lang_143"), class))
end
end

return 0
end

-- reglist functions end

-- say functions begin

function sendsay (nick, message)
_, space = string.find (message, string.char (32))
user = repnickchars (string.sub (message, 1, space - 1))
message = string.sub (message, space + 1, -1)
ucl = getclass (nick)

if ((user == ledobotnick) or (user == botnick) or (user == opchatnick) or (user == nick)) or (getclass (user) < ucl) then
if notifysay == 1 then
cmsg = string.format (gettranslation ("lang_144"), nick, ucl, user, message)
VH:SendPMToAll (cmsg, feednick, classnotisay, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end

VH:SendDataToAll ("<"..user.."> "..message.."|", 0, 10)

if (histrunning == 1) and (histbotmsg == 1) then
addmchistoryline (user, message)
end

else
if notifysay == 1 then
cmsg = string.format (gettranslation ("lang_145"), nick, ucl, user, message)
VH:SendPMToAll (cmsg, feednick, classnotisay, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end

maintouser (nick, gettranslation ("lang_146"))
end

return 0
end

-- say functions end

-- donotify functions begin

function donotifykick (nick, line)
if notifykick == 1 then
_, space = string.find (line, string.char (32))
both = string.sub (line, space + 1, -1)
_, space = string.find (both, string.char (32))
user = string.sub (both, 1, space - 1)

if string.len (user) >= 1 then
if getstatus (user) == 1 then
reason = string.sub (both, space + 1, -1)

cmsg = string.format (gettranslation ("lang_147"), user, getip (user), nick, reason)
VH:SendPMToAll (cmsg, feednick, classnotikick, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end

else
cmsg = string.format (gettranslation ("lang_218"), nick, user)
VH:SendPMToAll (cmsg, feednick, classnotikick, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end
end
end

return 0
end

function donotifyprotokick (nick, user)
if (notifykick == 1) and (getclass (nick) >= 3) then
if getstatus (user) == 1 then
cmsg = string.format (gettranslation ("lang_148"), user, getip (user), nick)
VH:SendPMToAll (cmsg, feednick, classnotikick, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end

else
cmsg = string.format (gettranslation ("lang_218"), nick, user)
VH:SendPMToAll (cmsg, feednick, classnotikick, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end
end

return 0
end

function donotifyban (nick, line)
if notifyban == 1 then
_, space = string.find (line, string.char (32))
cmd = string.sub (line, 1, space - 1)
both = string.sub (line, space + 1, -1)
_, space = string.find (both, string.char (32))
user = string.sub (both, 1, space - 1)

if string.len (user) >= 1 then
reason = string.sub (both, space + 1, -1)
_, bantime = string.find (cmd, "_")

if bantime ~= nil then
bantime = string.sub (cmd, bantime + 1, -1)

if string.len (bantime) < 1 then
bantime = nil
end
end

if bantime == nil then
cmsg = string.format (gettranslation ("lang_104"), user, nick, reason)
else
cmsg = string.format (gettranslation ("lang_208"), user, bantime, nick, reason)
end

VH:SendPMToAll (cmsg, feednick, classnotiban, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end
end

return 0
end

function donotifyunban (nick, line)
if notifyban == 1 then
_, space = string.find (line, string.char (32))
both = string.sub (line, space + 1, -1)
_, space = string.find (both, string.char (32))
user = string.sub (both, 1, space - 1)

if string.len (user) >= 1 then
reason = string.sub (both, space + 1, -1)
cmsg = string.format (gettranslation ("lang_150"), user, nick, reason)
VH:SendPMToAll (cmsg, feednick, classnotiban, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end
end

return 0
end

function donotifyconfig (nick, line)
_, space = string.find (line, string.char (32))
cname = string.sub (line, 1, space - 1)
cvalu = string.sub (line, space + 1, -1)

if notifyconfig == 1 then
cmsg = string.format (gettranslation ("lang_217"), nick, cname, cvalu)
VH:SendPMToAll (cmsg, feednick, classnoticonfig, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end

if cname == "hub_security" then
botnick = repnickchars (cvalu)
elseif cname == "opchat_name" then
opchatnick = repnickchars (cvalu)

if (notifytoledobot == 0) or (addledobot == 0) then
feednick = opchatnick
end

elseif cname == "cmd_start_op" then
optrig = cvalu
elseif cname == "cmd_start_user" then
ustrig = cvalu
end

return 0
end

function donotifyredir (nick, line)
if notifyredir == 1 then
min_class_redir = getconfig ("min_class_redir")

if tonumber (min_class_redir) then
min_class_redir = tonumber (min_class_redir)
else
min_class_redir = 3
end

_, poswho = string.find (line, "%$Who:")
_, poswhere = string.find (line, "%$Where:")
_, posmsg = string.find (line, "%$Msg:")

who = string.sub (line, poswho + 1, poswhere - 7)
where = string.sub (line, poswhere + 1, posmsg - 5)
msg = string.sub (line, posmsg + 1, -1)

if getclass (nick) >= min_class_redir then
if getstatus (who) == 1 then
if string.len (msg) < 1 then
cmsg = string.format (gettranslation ("lang_151"), who, getip (who), nick, where)
else
cmsg = string.format (gettranslation ("lang_152"), who, getip (who), where, nick, msg)
end

VH:SendPMToAll (cmsg, feednick, classnotiredir, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end

else
cmsg = string.format (gettranslation ("lang_219"), nick, who)
VH:SendPMToAll (cmsg, feednick, classnotiredir, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end

else

if string.len (msg) < 1 then
cmsg = string.format (gettranslation ("lang_178"), nick, getip (nick), getclass (nick), who, where)
else
cmsg = string.format (gettranslation ("lang_220"), nick, getip (nick), getclass (nick), who, where, msg)
end

VH:SendPMToAll (cmsg, feednick, classnotiredir, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end
end

return 0
end

function donotifyunk (nick, line)
if notifyunk == 1 then
if string.find (line, "^%$UserIP .+$") then
-- skip it since not implemented in verlihub

elseif string.len (line) < 1 then
-- empty protocol message?

else
cmsg = string.format (gettranslation ("lang_153"), nick, getip (nick), repnmdcchars (line))
VH:SendPMToAll (cmsg, feednick, classnotiunk, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistorymsg (opchatnick, cmsg)
end
end
end

return 0
end

function donotifycommand (nick, cmd)
cmsg = string.format (gettranslation ("lang_103"), nick, getclass (nick), cmd)
VH:SendPMToAll (cmsg, feednick, classnoticom, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end

return 0
end

-- donotify functions end

-- ledokol functions begin

function getledoconf (tvar, anum)
res, rows = VH:SQLQuery ("select `value` from `script_ledokol_settings` where `variable`='"..tvar.."' limit 1")
config = 0

if (res) and (rows > 0) then
res, config = VH:SQLFetch (0)
end

res, err = VH:SQLFree ()

if anum == 1 then
config = tonumber (config)
end

return config
end

function setledoconf (nick, line)
_, space = string.find (line, string.char (32))
tvar = string.sub (line, 1, space - 1)
setto = string.sub (line, space + 1, -1)
lang_195 = gettranslation ("lang_195")
lang_196 = gettranslation ("lang_196")
lang_197 = gettranslation ("lang_197")
lang_198 = gettranslation ("lang_198")
lang_199 = gettranslation ("lang_199")

if tvar == "enableantispam" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
enableantispam = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "0 "..lang_197.." 1"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "allowspamtoops" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
allowspamtoops = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "0 "..lang_197.." 1"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "thirdacttime" then
thirdacttime = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..repsqlchars (setto).."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))

elseif tvar == "scanbelowclass" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) then
scanbelowclass = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "1, 2, 3, 4, 5 "..lang_197.." 10"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "showtopicowner" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
showtopicowner = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "0 "..lang_197.." 1"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "enablechatranks" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
enablechatranks = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "0 "..lang_197.." 1"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "enableopranks" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
enableopranks = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "0 "..lang_197.." 1"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "ranklimit" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto >= 1) and (setto <= 999) then
ranklimit = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "1 "..lang_199.." 999"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "notifyanti" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
notifyanti = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "0 "..lang_197.." 1"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "notifyex" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
notifyex = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "0 "..lang_197.." 1"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "notifycom" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
notifycom = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "0 "..lang_197.." 1"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "notifysay" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
notifysay = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "0 "..lang_197.." 1"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "notifykick" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
notifykick = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "0 "..lang_197.." 1"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "notifyban" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
notifyban = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "0 "..lang_197.." 1"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "notifyconfig" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
notifyconfig = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "0 "..lang_197.." 1"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "notifyredir" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
notifyredir = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "0 "..lang_197.." 1"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "notifyunk" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
notifyunk = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "0 "..lang_197.." 1"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "notifymyinf" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
notifymyinf = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "0 "..lang_197.." 1"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "notifymyinfex" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
notifymyinfex = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "0 "..lang_197.." 1"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "notifyoff" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
notifyoff = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "0 "..lang_197.." 1"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "notifyledoact" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
notifyledoact = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "0 "..lang_197.." 1"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "classnotianti" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) then
classnotianti = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "3, 4, 5 "..lang_197.." 10"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "classnotiex" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) then
classnotiex = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "3, 4, 5 "..lang_197.." 10"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "classnoticom" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) then
classnoticom = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "3, 4, 5 "..lang_197.." 10"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "classnotisay" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) then
classnotisay = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "3, 4, 5 "..lang_197.." 10"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "classnotikick" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) then
classnotikick = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "3, 4, 5 "..lang_197.." 10"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "classnotiban" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) then
classnotiban = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "3, 4, 5 "..lang_197.." 10"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "classnoticonfig" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) then
classnoticonfig = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "3, 4, 5 "..lang_197.." 10"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "classnotiredir" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) then
classnotiredir = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "3, 4, 5 "..lang_197.." 10"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "classnotiunk" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) then
classnotiunk = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "3, 4, 5 "..lang_197.." 10"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "classnotimyinf" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) then
classnotimyinf = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "3, 4, 5 "..lang_197.." 10"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "classnotimyinfex" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) then
classnotimyinfex = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "3, 4, 5 "..lang_197.." 10"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "classnotioff" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) then
classnotioff = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "3, 4, 5 "..lang_197.." 10"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "classnotiledoact" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) then
classnotiledoact = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "3, 4, 5 "..lang_197.." 10"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "mincommandclass" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) then
mincommandclass = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "3, 4, 5 "..lang_197.." 10"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "minusrcommandclass" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) then
minusrcommandclass = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "0, 1, 2, 3, 4, 5 "..lang_197.." 10"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "antimessage" then
antimessage = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..repsqlchars (setto).."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))

elseif tvar == "antikreason" then
antikreason = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..repsqlchars (setto).."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))

elseif tvar == "remrunning" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
remrunning = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))

if setto == 0 then
remseconds = 0
end

else
maintouser (nick, string.format (lang_196, tvar, "0 "..lang_197.." 1"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "rempmmode" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
rempmmode = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "0 "..lang_197.." 1"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "reminterval" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto >= 60) and (setto <= 604800) then
reminterval = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "60 "..lang_199.." 604800"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "remminclass" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) then
remminclass = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "0, 1, 2, 3, 4, 5 "..lang_197.." 10"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "remmaxclass" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) or (setto == 2) or (setto == 3) or (setto == 4) or (setto == 5) or (setto == 10) then
remmaxclass = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "0, 1, 2, 3, 4, 5 "..lang_197.." 10"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "remtext" then
remtext = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..repsqlchars (setto).."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))

elseif tvar == "micheck" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
micheck = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "0 "..lang_197.." 1"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "michnick" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
michnick = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "0 "..lang_197.." 1"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "michdesc" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
michdesc = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "0 "..lang_197.." 1"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "michtag" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
michtag = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "0 "..lang_197.." 1"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "michconn" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
michconn = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "0 "..lang_197.." 1"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "michemail" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
michemail = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "0 "..lang_197.." 1"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "michshare" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
michshare = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "0 "..lang_197.." 1"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "michclone" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
michclone = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "0 "..lang_197.." 1"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "mitbantime" then
mitbantime = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..repsqlchars (setto).."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))

elseif tvar == "minickmessage" then
minickmessage = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..repsqlchars (setto).."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))

elseif tvar == "midescmessage" then
midescmessage = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..repsqlchars (setto).."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))

elseif tvar == "mitagmessage" then
mitagmessage = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..repsqlchars (setto).."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))

elseif tvar == "miconnmessage" then
miconnmessage = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..repsqlchars (setto).."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))

elseif tvar == "miemailmessage" then
miemailmessage = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..repsqlchars (setto).."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))

elseif tvar == "misharemessage" then
misharemessage = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..repsqlchars (setto).."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))

elseif tvar == "miclonemessage" then
miclonemessage = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..repsqlchars (setto).."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))

elseif tvar == "offrunning" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
offrunning = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "0 "..lang_197.." 1"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "histrunning" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
histrunning = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "0 "..lang_197.." 1"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "histbotmsg" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
histbotmsg = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "0 "..lang_197.." 1"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "histlimit" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto >= 1) and (setto <= 999) then
histlimit = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "1 "..lang_199.." 999"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

res, rows = VH:SQLQuery ("select `date` from `script_ledokol_mchistory` order by `date` asc")

if (res) and (rows > histlimit) then
rmrows = rows - histlimit
hentry = ""

for x = 0, rmrows - 1 do
res, hdate = VH:SQLFetch (x)
hentry = hentry..hdate.."$$"
end

for hdate in string.gfind (hentry, "([^$]+)%$%$") do
res, rows = VH:SQLQuery ("delete from `script_ledokol_mchistory` where `date`='"..hdate.."' limit 1")
end

maintouser (nick, string.format (gettranslation ("lang_011"), rmrows))
end

res, rows = VH:SQLQuery ("select `date` from `script_ledokol_ophistory` order by `date` asc")

if (res) and (rows > histlimit) then
rmrows = rows - histlimit
hentry = ""

for x = 0, rmrows - 1 do
res, hdate = VH:SQLFetch (x)
hentry = hentry..hdate.."$$"
end

for hdate in string.gfind (hentry, "([^$]+)%$%$") do
res, rows = VH:SQLQuery ("delete from `script_ledokol_ophistory` where `date`='"..hdate.."' limit 1")
end

maintouser (nick, string.format (gettranslation ("lang_013"), rmrows))
end

elseif tvar == "addledobot" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
addledobot = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))

if addledobot == 0 then
feednick = opchatnick
ledobotdel ()
else
ledobotadd ()

if notifytoledobot == 1 then
feednick = ledobotnick
end
end

else
maintouser (nick, string.format (lang_196, tvar, "0 "..lang_197.." 1"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "notifytoledobot" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
notifytoledobot = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))

if addledobot == 1 then
if notifytoledobot == 0 then
feednick = opchatnick
else
feednick = ledobotnick
end

else
feednick = opchatnick
end

else
maintouser (nick, string.format (lang_196, tvar, "0 "..lang_197.." 1"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

elseif tvar == "ledobotnick" then
oldledonick = ledobotnick

if (addledobot == 1) and (setto ~= oldledonick) then
ledobotdel ()
end

setto = repnickchars (setto)
ledobotnick = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..repsqlchars (setto).."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))

if (addledobot == 1) and (ledobotnick ~= oldledonick) then
ledobotadd ()

if notifytoledobot == 1 then
feednick = ledobotnick
end
end

elseif tvar == "commandstopm" then
if tonumber (setto) then
setto = tonumber (setto)

if (setto == 0) or (setto == 1) then
commandstopm = setto
res, err = VH:SQLQuery ("update `script_ledokol_settings` set `value`='"..setto.."' where `variable`='"..tvar.."' limit 1")
maintouser (nick, string.format (lang_195, tvar, setto))
else
maintouser (nick, string.format (lang_196, tvar, "0 "..lang_197.." 1"))
end

else
maintouser (nick, string.format (lang_198, tvar))
end

else
maintouser (nick, string.format (gettranslation ("lang_200"), tvar))
end

res, err = VH:SQLFree ()

return 0
end

function sendhelp (nick)
res, entchatran = VH:SQLQuery ("select `rank` from `script_ledokol_chatranks`")
res, entopran = VH:SQLQuery ("select `rank` from `script_ledokol_opranks`")
res, err = VH:SQLFree ()
cntchatran = countchatranks ()

if entchatran > ranklimit then
topchatran = ranklimit
else
topchatran = entchatran
end

if entopran > ranklimit then
topopran = ranklimit
else
topopran = entopran
end

if entchatran == 0 then
mesperuser = 0
else
mesperuser = cntchatran / entchatran
end

atextlines = gettranslation ("lang_155")..":\r\n\r\n "..
optrig..command_antiadd.." <"..gettranslation ("lang_193").."> <"..gettranslation ("lang_194").."> - "..gettranslation ("lang_156").."\r\n "..
optrig..command_antimod.." <"..gettranslation ("lang_193").."> <"..gettranslation ("lang_194").."> - "..gettranslation ("lang_157").."\r\n "..
optrig..command_antidel.." <"..gettranslation ("lang_193").."> - "..gettranslation ("lang_158").."\r\n "..
optrig..command_antilist.." - "..gettranslation ("lang_131").."\r\n "..
optrig..command_exadd.." <"..gettranslation ("lang_193").."> - "..gettranslation ("lang_159").."\r\n "..
optrig..command_exdel.." <"..gettranslation ("lang_193").."> - "..gettranslation ("lang_160").."\r\n "..
optrig..command_exlist.." - "..gettranslation ("lang_137").."\r\n "..
optrig..command_myinfadd.." <"..gettranslation ("lang_212").."> <"..gettranslation ("lang_193").."> - "..gettranslation ("lang_161").."\r\n "..
optrig..command_myinfdel.." <"..gettranslation ("lang_212").."> <"..gettranslation ("lang_193").."> - "..gettranslation ("lang_162").."\r\n "..
optrig..command_myinflist.." <"..gettranslation ("lang_212").."> - "..gettranslation ("lang_163").."\r\n "..
optrig..command_reglist.." <"..gettranslation ("lang_171").."> <"..gettranslation ("lang_149").."> - "..gettranslation ("lang_164").."\r\n "..
optrig..command_say.." <"..gettranslation ("lang_210").."> <"..gettranslation ("lang_211").."> - "..gettranslation ("lang_165").."\r\n "..
optrig..command_chatrandel.." <"..gettranslation ("lang_210").."> - "..gettranslation ("lang_166").."\r\n "..
optrig..command_oprandel.." <"..gettranslation ("lang_210").."> - "..gettranslation ("lang_167").."\r\n "..
optrig..command_offlist.." - "..gettranslation ("lang_168").."\r\n "..
optrig..command_offdel.." <"..gettranslation ("lang_102").."> - "..gettranslation ("lang_169").."\r\n "..
optrig..command_offclean.." - "..gettranslation ("lang_170").."\r\n "..
optrig..command_cleanup.." <"..gettranslation ("lang_212").."> <"..gettranslation ("lang_004").."> - "..gettranslation ("lang_172").."\r\n "..
optrig..command_ophist.." <"..gettranslation ("lang_209").."> - "..gettranslation ("lang_173").."\r\n "

btextlines = optrig..command_histclean.." - "..gettranslation ("lang_174").."\r\n "..
ustrig..command_myoprank.." - "..gettranslation ("lang_175").."\r\n "..
optrig..command_ledoconf.." - "..gettranslation ("lang_176").."\r\n "..
optrig..command_ledoset.." <"..gettranslation ("lang_214").."> <"..gettranslation ("lang_213").."> - "..gettranslation ("lang_177").."\r\n "..
optrig..command_ledover.." - "..gettranslation ("lang_010").."\r\n "..
optrig..command_ledohelp.." - "..gettranslation ("lang_179")..
"\r\n\r\n "..gettranslation ("lang_180")..":\r\n\r\n "..
ustrig..command_showtopic.." - "..gettranslation ("lang_181").."\r\n "..
ustrig..command_mychatrank.." - "..gettranslation ("lang_182").."\r\n "..
ustrig..command_chatranks.." - "..string.format (gettranslation ("lang_116"), topchatran).."\r\n "..
ustrig..command_opranks.." - "..string.format (gettranslation ("lang_118"), topopran).."\r\n "..
ustrig..command_remind.." - "..gettranslation ("lang_185").."\r\n "..
ustrig..command_offmsg.." <"..gettranslation ("lang_210").."> <"..gettranslation ("lang_211").."> - "..gettranslation ("lang_186").."\r\n "..
ustrig..command_history.." <"..gettranslation ("lang_209").."> - "..gettranslation ("lang_187")..""..
"\r\n\r\n "..gettranslation ("lang_188")..":"..
"\r\n\r\n "..string.format (gettranslation ("lang_189"), ledover)..
"\r\n "..string.format (gettranslation ("lang_190"), cntchatran)..
"\r\n "..string.format (gettranslation ("lang_191"), countopranks ())..
"\r\n "..string.format (gettranslation ("lang_192"), roundint (mesperuser, 2)).."\r\n"

if commandstopm == 0 then
maintouser (nick, atextlines..btextlines)
else
pmfrombot (nick, atextlines..btextlines)
end

return 0
end

function showledoconf (nick)
textlines = gettranslation ("lang_176")..":\r\n"..
"\r\n enableantispam = "..enableantispam..
"\r\n allowspamtoops = "..allowspamtoops..
"\r\n thirdacttime = "..thirdacttime..
"\r\n scanbelowclass = "..scanbelowclass..
"\r\n showtopicowner = "..showtopicowner..
"\r\n enablechatranks = "..enablechatranks..
"\r\n enableopranks = "..enableopranks..
"\r\n ranklimit = "..ranklimit..
"\r\n notifyanti = "..notifyanti..
"\r\n notifyex = "..notifyex..
"\r\n notifycom = "..notifycom..
"\r\n notifysay = "..notifysay..
"\r\n notifykick = "..notifykick..
"\r\n notifyban = "..notifyban..
"\r\n notifyconfig = "..notifyconfig..
"\r\n notifyredir = "..notifyredir..
"\r\n notifyunk = "..notifyunk..
"\r\n notifymyinf = "..notifymyinf..
"\r\n notifymyinfex = "..notifymyinfex..
"\r\n notifyoff = "..notifyoff..
"\r\n notifyledoact = "..notifyledoact..
"\r\n classnotianti = "..classnotianti..
"\r\n classnotiex = "..classnotiex..
"\r\n classnoticom = "..classnoticom..
"\r\n classnotisay = "..classnotisay..
"\r\n classnotikick = "..classnotikick..
"\r\n classnotiban = "..classnotiban..
"\r\n classnoticonfig = "..classnoticonfig..
"\r\n classnotiredir = "..classnotiredir..
"\r\n classnotiunk = "..classnotiunk..
"\r\n classnotimyinf = "..classnotimyinf..
"\r\n classnotimyinfex = "..classnotimyinfex..
"\r\n classnotioff = "..classnotioff..
"\r\n classnotiledoact = "..classnotiledoact..
"\r\n mincommandclass = "..mincommandclass..
"\r\n minusrcommandclass = "..minusrcommandclass..
"\r\n antimessage = "..antimessage..
"\r\n antikreason = "..antikreason..
"\r\n remrunning = "..remrunning..
"\r\n rempmmode = "..rempmmode..
"\r\n reminterval = "..reminterval..
"\r\n remminclass = "..remminclass..
"\r\n remmaxclass = "..remmaxclass..
"\r\n remtext = "..remtext..
"\r\n micheck = "..micheck..
"\r\n michnick = "..michnick..
"\r\n michdesc = "..michdesc..
"\r\n michtag = "..michtag..
"\r\n michconn = "..michconn..
"\r\n michemail = "..michemail..
"\r\n michshare = "..michshare..
"\r\n michclone = "..michclone..
"\r\n mitbantime = "..mitbantime..
"\r\n minickmessage = "..minickmessage..
"\r\n midescmessage = "..midescmessage..
"\r\n mitagmessage = "..mitagmessage..
"\r\n miconnmessage = "..miconnmessage..
"\r\n miemailmessage = "..miemailmessage..
"\r\n misharemessage = "..misharemessage..
"\r\n miclonemessage = "..miclonemessage..
"\r\n offrunning = "..offrunning..
"\r\n histrunning = "..histrunning..
"\r\n histbotmsg = "..histbotmsg..
"\r\n histlimit = "..histlimit..
"\r\n addledobot = "..addledobot..
"\r\n notifytoledobot = "..notifytoledobot..
"\r\n ledobotnick = "..ledobotnick..
"\r\n commandstopm = "..commandstopm.."\r\n"

if commandstopm == 0 then
maintouser (nick, textlines)
else
pmfrombot (nick, textlines)
end

return 0
end

function createtables ()
res, err = VH:SQLQuery ("create table if not exists `script_ledokol_settings` (`variable` varchar(25) not null, `value` text not null, primary key (`variable`))")
res, err = VH:SQLQuery ("create table if not exists `script_ledokol_antispam` (`antispam` varchar(255) not null, `occured` int(9) not null, `action` int(1) not null, primary key (`antispam`))")
res, err = VH:SQLQuery ("create table if not exists `script_ledokol_exceptions` (`exception` varchar(255) not null, `occured` int(9) not null, primary key (`exception`))")
res, err = VH:SQLQuery ("create table if not exists `script_ledokol_chatranks` (`nick` varchar(255) not null, `rank` int(9) not null, primary key (`nick`))")
res, err = VH:SQLQuery ("create table if not exists `script_ledokol_opranks` (`nick` varchar(255) not null, `rank` int(9) not null, primary key (`nick`))")
res, err = VH:SQLQuery ("create table if not exists `script_ledokol_nicks` (`nick` varchar(255) not null, `occured` int(9) not null, primary key (`nick`))")
res, err = VH:SQLQuery ("create table if not exists `script_ledokol_descriptions` (`description` varchar(255) not null, `occured` int(9) not null, primary key (`description`))")
res, err = VH:SQLQuery ("create table if not exists `script_ledokol_tags` (`tag` varchar(255) not null, `occured` int(9) not null, primary key (`tag`))")
res, err = VH:SQLQuery ("create table if not exists `script_ledokol_connections` (`connection` varchar(255) not null, `occured` int(9) not null, primary key (`connection`))")
res, err = VH:SQLQuery ("create table if not exists `script_ledokol_emails` (`email` varchar(255) not null, `occured` int(9) not null, primary key (`email`))")
res, err = VH:SQLQuery ("create table if not exists `script_ledokol_shares` (`share` varchar(255) not null, `occured` int(9) not null, primary key (`share`))")
res, err = VH:SQLQuery ("create table if not exists `script_ledokol_myinfoexceptions` (`exception` varchar(255) not null, `occured` int(9) not null, primary key (`exception`))")
res, err = VH:SQLQuery ("create table if not exists `script_ledokol_offline` (`id` int(9) not null auto_increment, `from` varchar(255) not null, `ip` varchar(15) not null, `to` varchar(255) not null, `date` varchar(19) not null, `message` text not null, primary key (`id`))")
res, err = VH:SQLQuery ("create table if not exists `script_ledokol_mchistory` (`id` int(9) not null auto_increment, `nick` varchar(255) not null, `date` varchar(19) not null, `message` text not null, primary key (`id`))")
res, err = VH:SQLQuery ("create table if not exists `script_ledokol_ophistory` (`id` int(9) not null auto_increment, `nick` varchar(255) not null, `date` varchar(19) not null, `message` text not null, primary key (`id`))")

res, err = VH:SQLFree ()

return 0
end

--function altertables ()
--res, err = VH:SQLQuery ("alter table `script_ledokol_table`")
--res, err = VH:SQLFree ()
--
--return 0
--end

function createsettings ()
res, err = VH:SQLQuery ("insert ignore into `script_ledokol_settings` (`variable`, `value`) values ".. -- shit lua limits again, part one

"('enableantispam', '"..enableantispam.."'), "..
"('allowspamtoops', '"..allowspamtoops.."'), "..
"('thirdacttime', '"..repsqlchars (thirdacttime).."'), "..
"('scanbelowclass', '"..scanbelowclass.."'), "..
"('showtopicowner', '"..showtopicowner.."'), "..
"('enablechatranks', '"..enablechatranks.."'), "..
"('enableopranks', '"..enableopranks.."'), "..
"('ranklimit', '"..ranklimit.."'), "..
"('notifyanti', '"..notifyanti.."'), "..
"('notifyex', '"..notifyex.."'), "..
"('notifycom', '"..notifycom.."'), "..
"('notifysay', '"..notifysay.."'), "..
"('notifykick', '"..notifykick.."'), "..
"('notifyban', '"..notifyban.."'), "..
"('notifyconfig', '"..notifyconfig.."'), "..
"('notifyredir', '"..notifyredir.."'), "..
"('notifyunk', '"..notifyunk.."'), "..
"('notifymyinf', '"..notifymyinf.."'), "..
"('notifymyinfex', '"..notifymyinfex.."'), "..
"('notifyoff', '"..notifyoff.."'), "..
"('notifyledoact', '"..notifyledoact.."'), "..
"('classnotianti', '"..classnotianti.."'), "..
"('classnotiex', '"..classnotiex.."'), "..
"('classnoticom', '"..classnoticom.."'), "..
"('classnotisay', '"..classnotisay.."'), "..
"('classnotikick', '"..classnotikick.."'), "..
"('classnotiban', '"..classnotiban.."'), "..
"('classnoticonfig', '"..classnoticonfig.."'), "..
"('classnotiredir', '"..classnotiredir.."'), "..
"('classnotiunk', '"..classnotiunk.."'), "..
"('classnotimyinf', '"..classnotimyinf.."'), "..
"('classnotimyinfex', '"..classnotimyinfex.."'), "..
"('classnotioff', '"..classnotioff.."'), "..
"('classnotiledoact', '"..classnotiledoact.."'), "..
"('mincommandclass', '"..mincommandclass.."'), "..
"('minusrcommandclass', '"..minusrcommandclass.."')")

res, err = VH:SQLQuery ("insert ignore into `script_ledokol_settings` (`variable`, `value`) values ".. -- part two

"('antimessage', '"..repsqlchars (antimessage).."'), "..
"('antikreason', '"..repsqlchars (antikreason).."'), "..
"('remrunning', '"..remrunning.."'), "..
"('rempmmode', '"..rempmmode.."'), "..
"('reminterval', '"..reminterval.."'), "..
"('remminclass', '"..remminclass.."'), "..
"('remmaxclass', '"..remmaxclass.."'), "..
"('remtext', '"..repsqlchars (remtext).."'), "..
"('micheck', '"..micheck.."'), "..
"('michnick', '"..michnick.."'), "..
"('michdesc', '"..michdesc.."'), "..
"('michtag', '"..michtag.."'), "..
"('michconn', '"..michconn.."'), "..
"('michemail', '"..michemail.."'), "..
"('michshare', '"..michshare.."'), "..
"('michclone', '"..michclone.."'), "..
"('mitbantime', '"..repsqlchars (mitbantime).."'), "..
"('minickmessage', '"..repsqlchars (minickmessage).."'), "..
"('midescmessage', '"..repsqlchars (midescmessage).."'), "..
"('mitagmessage', '"..repsqlchars (mitagmessage).."'), "..
"('miconnmessage', '"..repsqlchars (miconnmessage).."'), "..
"('miemailmessage', '"..repsqlchars (miemailmessage).."'), "..
"('misharemessage', '"..repsqlchars (misharemessage).."'), "..
"('miclonemessage', '"..repsqlchars (miclonemessage).."'), "..
"('offrunning', '"..offrunning.."'), "..
"('histrunning', '"..histrunning.."'), "..
"('histbotmsg', '"..histbotmsg.."'), "..
"('histlimit', '"..histlimit.."'), "..
"('addledobot', '"..addledobot.."'), "..
"('notifytoledobot', '"..notifytoledobot.."'), "..
"('ledobotnick', '"..repsqlchars (ledobotnick).."'), "..
"('commandstopm', '"..commandstopm.."')")

res, err = VH:SQLFree ()

return 0
end

function loadsettings ()
enableantispam = getledoconf ("enableantispam", 1)
allowspamtoops = getledoconf ("allowspamtoops", 1)
thirdacttime = getledoconf ("thirdacttime", 0)
scanbelowclass = getledoconf ("scanbelowclass", 1)
showtopicowner = getledoconf ("showtopicowner", 1)
enablechatranks = getledoconf ("enablechatranks", 1)
enableopranks = getledoconf ("enableopranks", 1)
ranklimit = getledoconf ("ranklimit", 1)
notifyanti = getledoconf ("notifyanti", 1)
notifyex = getledoconf ("notifyex", 1)
notifycom = getledoconf ("notifycom", 1)
notifysay = getledoconf ("notifysay", 1)
notifykick = getledoconf ("notifykick", 1)
notifyban = getledoconf ("notifyban", 1)
notifyconfig = getledoconf ("notifyconfig", 1)
notifyredir = getledoconf ("notifyredir", 1)
notifyunk = getledoconf ("notifyunk", 1)
notifymyinf = getledoconf ("notifymyinf", 1)
notifymyinfex = getledoconf ("notifymyinfex", 1)
notifyoff = getledoconf ("notifyoff", 1)
notifyledoact = getledoconf ("notifyledoact", 1)
classnotianti = getledoconf ("classnotianti", 1)
classnotiex = getledoconf ("classnotiex", 1)
classnoticom = getledoconf ("classnoticom", 1)
classnotisay = getledoconf ("classnotisay", 1)
classnotikick = getledoconf ("classnotikick", 1)
classnotiban = getledoconf ("classnotiban", 1)
classnoticonfig = getledoconf ("classnoticonfig", 1)
classnotiredir = getledoconf ("classnotiredir", 1)
classnotiunk = getledoconf ("classnotiunk", 1)
classnotimyinf = getledoconf ("classnotimyinf", 1)
classnotimyinfex = getledoconf ("classnotimyinfex", 1)
classnotioff = getledoconf ("classnotioff", 1)
classnotiledoact = getledoconf ("classnotiledoact", 1)
mincommandclass = getledoconf ("mincommandclass", 1)
minusrcommandclass = getledoconf ("minusrcommandclass", 1)
antimessage = getledoconf ("antimessage", 0)
antikreason = getledoconf ("antikreason", 0)
remrunning = getledoconf ("remrunning", 1)
rempmmode = getledoconf ("rempmmode", 1)
reminterval = getledoconf ("reminterval", 1)
remminclass = getledoconf ("remminclass", 1)
remmaxclass = getledoconf ("remmaxclass", 1)
remtext = getledoconf ("remtext", 0)
micheck = getledoconf ("micheck", 1)
michnick = getledoconf ("michnick", 1)
michdesc = getledoconf ("michdesc", 1)
michtag = getledoconf ("michtag", 1)
michconn = getledoconf ("michconn", 1)
michemail = getledoconf ("michemail", 1)
michshare = getledoconf ("michshare", 1)
michclone = getledoconf ("michclone", 1)
mitbantime = getledoconf ("mitbantime", 0)
minickmessage = getledoconf ("minickmessage", 0)
midescmessage = getledoconf ("midescmessage", 0)
mitagmessage = getledoconf ("mitagmessage", 0)
miconnmessage = getledoconf ("miconnmessage", 0)
miemailmessage = getledoconf ("miemailmessage", 0)
misharemessage = getledoconf ("misharemessage", 0)
miclonemessage = getledoconf ("miclonemessage", 0)
offrunning = getledoconf ("offrunning", 1)
histrunning = getledoconf ("histrunning", 1)
histbotmsg = getledoconf ("histbotmsg", 1)
histlimit = getledoconf ("histlimit", 1)
addledobot = getledoconf ("addledobot", 1)
notifytoledobot = getledoconf ("notifytoledobot", 1)
ledobotnick = getledoconf ("ledobotnick", 0)
commandstopm = getledoconf ("commandstopm", 1)

return 0
end

function gettranslation (tvar)
tval = "[if you see this text please report to script developer]"

for k, v in pairs (table_lang) do
if k == tvar then

return v
end
end

return tval
end

function ledobotadd ()
res, err = VH:AddRobot (ledobotnick, 10, "Advanced hub security<Ledokol V:"..ledover..",M:A,H:0/0/1,S:0>", "Bot"..string.char (1), "", "0")

return 0
end

function ledobotdel ()
res, err = VH:DelRobot (ledobotnick)

return 0
end

-- ledokol functions end

-- get functions begin

function getstatus (nick)
res, nicklist = VH:GetNickList ()
res = 1 -- temporary bug fix

if res then
nicklist = string.sub (nicklist, 11)

for user in string.gfind (nicklist, "([^$]+)%$%$") do
if string.lower (user) == string.lower (nick) then

return 1
end
end
end

return 0
end

function getclass (nick)
res, class = VH:GetUserClass (nick)

if res == 0 then
class = -1
end

return class
end

function getip (nick)
res, ip = VH:GetUserIP (nick)

if (res == 0) or (string.len (ip) < 1) then
ip = "x.x.x.x"
end

return ip
end

function gethost (nick)
res, host = VH:GetUserHost (nick)

if (res == 0) or (string.len (host) < 1) then
host = "unknown host"
end

return host
end

function getconfig (tvar)
res, config = VH:GetConfig ("config", tvar)

if res == 0 then
config = nil
end

return config
end

-- get functions end

-- other functions begin

function repsqlchars (txt)
txt = string.gsub (txt, string.char (92), string.char (92)..string.char (92)) -- backslash
txt = string.gsub (txt, string.char (39), string.char (39)..string.char (39)) -- single quote

return txt
end

function reprexpchars (txt)
txt = string.gsub (txt, "%$", "&#36;")
txt = string.gsub (txt, "%%", "&#37;")
txt = string.gsub (txt, "%(", "&#40;")
txt = string.gsub (txt, "%)", "&#41;")
txt = string.gsub (txt, "%*", "&#42;")
txt = string.gsub (txt, "%+", "&#43;")
txt = string.gsub (txt, "%-", "&#45;")
txt = string.gsub (txt, "%.", "&#46;")
txt = string.gsub (txt, "%?", "&#63;")
txt = string.gsub (txt, "%[", "&#91;")
txt = string.gsub (txt, "%]", "&#93;")
txt = string.gsub (txt, "%^", "&#94;")

return txt
end

function repnmdcchars (txt)
txt = string.gsub (txt, "%$", "&#36;")
txt = string.gsub (txt, "|", "&#124;")

return txt
end

function repnickchars (txt)
txt = string.gsub (txt, "<", "_")
txt = string.gsub (txt, ">", "_")
txt = string.gsub (txt, " ", "_")

return txt
end

function fromunixtime (nixtime)
if tonumber (nixtime) then
nixtime = tonumber (nixtime)
else
nixtime = 0
end

if nixtime == 0 then
date = "0000-00-00 00:00:00"
else
date = os.date ("%Y-%m-%d %H:%M:%S", nixtime)
end

return date
end

function inleadingzeroes (maxlen, curlen)
curlen = string.len (curlen)
zeroes = ""

if maxlen > curlen then
for x = 1, maxlen - curlen do
zeroes = zeroes.."0"
end
end

return zeroes
end

function roundint (int, len)
int = tonumber (string.format ("%."..(len or 0).."f", int))

return int
end

-- other functions end

-- scan text functions begin

function scanofftext (nick, text, to)
scanit = 1
unclass = getclass (nick)

if (allowspamtoops == 1) and (getclass (to) > 2) then -- don't scan messages to operators if enabled
scanit = 0
end

if (enableantispam == 1) and (unclass < scanbelowclass) and (scanit == 1) then
res, rows = VH:SQLQuery ("select `antispam`, `occured`, `action` from `script_ledokol_antispam` order by `action` desc")

if (res) and (rows > 0) then
lowtxt = string.lower (text)

for x = 0, rows - 1 do
res, entry, occured, aaction = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
occured = occured + 1
res, err = VH:SQLQuery ("update `script_ledokol_antispam` set `occured`='"..occured.."' where `antispam`='"..repsqlchars (entry).."' limit 1")
res, rows = VH:SQLQuery ("select `exception`, `occured` from `script_ledokol_exceptions`")

if (res) and (rows > 0) then
for x = 0, rows - 1 do
res, entry, occured = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
occured = occured + 1
res, err = VH:SQLQuery ("update `script_ledokol_exceptions` set `occured`='"..occured.."' where `exception`='"..repsqlchars (entry).."' limit 1")

if notifyex == 1 then
cmsg = string.format (gettranslation ("lang_201"), nick, getip (nick), unclass, text)
VH:SendPMToAll (cmsg, feednick, classnotiex, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end

res, err = VH:SQLFree ()

return 1
end
end
end

if notifyanti == 1 then
cmsg = string.format (gettranslation ("lang_202"), nick, getip (nick), unclass, text)
VH:SendPMToAll (cmsg, feednick, classnotianti, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end

asaction = tonumber (aaction)

if asaction == 4 then
if getstatus (to) == 1 then
maintouser (nick, string.format (gettranslation ("lang_027"), to))
else
maintouser (nick, string.format (gettranslation ("lang_028"), to))
end

else
maintouser (nick, antimessage)
end

if addledobot == 1 then
sendfrom = ledobotnick
else
sendfrom = botnick
end

if asaction == 1 then
res, err = VH:CloseConnection (nick)

if notifyanti == 1 then
cmsg = string.format (gettranslation ("lang_203"), nick)
VH:SendPMToAll (cmsg, feednick, classnotianti, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end

elseif asaction == 2 then
res, err = VH:KickUser (sendfrom, nick, string.gsub (antikreason, "%*", text))

if notifyanti == 1 then
cmsg = string.format (gettranslation ("lang_204"), nick)
VH:SendPMToAll (cmsg, feednick, classnotianti, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end

elseif asaction == 3 then
res, err = VH:KickUser (sendfrom, nick, string.gsub (antikreason, "%*", text).." ledo_ban_"..thirdacttime)

if notifyanti == 1 then
cmsg = string.format (gettranslation ("lang_205"), nick, thirdacttime)
VH:SendPMToAll (cmsg, feednick, classnotianti, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end

elseif asaction == 4 then
if notifyanti == 1 then
cmsg = string.format (gettranslation ("lang_216"), nick)
VH:SendPMToAll (cmsg, feednick, classnotianti, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end
end

res, err = VH:SQLFree ()

return 0
end
end
end

res, err = VH:SQLFree ()
end

return 1
end

function scanpmtext (from, to, text)
scanit = 1
ufclass = getclass (from)

if (allowspamtoops == 1) and (getclass (to) > 2) then -- don't scan messages to operators if enabled
scanit = 0
end

if (enableantispam == 1) and (ufclass < scanbelowclass) and (scanit == 1) and (string.len (text) >= 1) then -- don't scan empty messages
res, rows = VH:SQLQuery ("select `antispam`, `occured`, `action` from `script_ledokol_antispam` order by `action` desc")

if (res) and (rows > 0) then
lowtxt = string.lower (text)

for x = 0, rows - 1 do
res, entry, occured, aaction = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
occured = occured + 1
res, err = VH:SQLQuery ("update `script_ledokol_antispam` set `occured`='"..occured.."' where `antispam`='"..repsqlchars (entry).."' limit 1")
res, rows = VH:SQLQuery ("select `exception`, `occured` from `script_ledokol_exceptions`")

if (res) and (rows > 0) then
for x = 0, rows - 1 do
res, entry, occured = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
occured = occured + 1
res, err = VH:SQLQuery ("update `script_ledokol_exceptions` set `occured`='"..occured.."' where `exception`='"..repsqlchars (entry).."' limit 1")

if notifyex == 1 then
cmsg = string.format (gettranslation ("lang_206"), from, getip (from), ufclass, text)
VH:SendPMToAll (cmsg, feednick, classnotiex, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end

res, err = VH:SQLFree ()

return 1
end
end
end

if notifyanti == 1 then
cmsg = string.format (gettranslation ("lang_207"), from, getip (from), ufclass, text)
VH:SendPMToAll (cmsg, feednick, classnotianti, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end

asaction = tonumber (aaction)

if asaction == 4 then
-- skip, let him see his own message and think it was sent
else
pmtouser (from, to, antimessage)
end

if addledobot == 1 then
sendfrom = ledobotnick
else
sendfrom = botnick
end

if asaction == 1 then
res, err = VH:CloseConnection (from)

if notifyanti == 1 then
cmsg = string.format (gettranslation ("lang_203"), from)
VH:SendPMToAll (cmsg, feednick, classnotianti, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end

elseif asaction == 2 then
res, err = VH:KickUser (sendfrom, from, string.gsub (antikreason, "%*", text))

if notifyanti == 1 then
cmsg = string.format (gettranslation ("lang_204"), from)
VH:SendPMToAll (cmsg, feednick, classnotianti, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end

elseif asaction == 3 then
res, err = VH:KickUser (sendfrom, from, string.gsub (antikreason, "%*", text).." ledo_ban_"..thirdacttime)

if notifyanti == 1 then
cmsg = string.format (gettranslation ("lang_205"), from, thirdacttime)
VH:SendPMToAll (cmsg, feednick, classnotianti, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end

elseif asaction == 4 then
if notifyanti == 1 then
cmsg = string.format (gettranslation ("lang_216"), from)
VH:SendPMToAll (cmsg, feednick, classnotianti, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end
end

res, err = VH:SQLFree ()

return 0
end
end
end

res, err = VH:SQLFree ()
end

return 1
end

function scanmctext (nick, text)
unclass = getclass (nick)

if (enableantispam == 1) and (unclass < scanbelowclass) and (string.len (text) >= 1) then -- don't scan empty messages
res, rows = VH:SQLQuery ("select `antispam`, `occured`, `action` from `script_ledokol_antispam` order by `action` desc")

if (res) and (rows > 0) then
lowtxt = string.lower (text)

for x = 0, rows - 1 do
res, entry, occured, aaction = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
occured = occured + 1
res, err = VH:SQLQuery ("update `script_ledokol_antispam` set `occured`='"..occured.."' where `antispam`='"..repsqlchars (entry).."' limit 1")
res, rows = VH:SQLQuery ("select `exception`, `occured` from `script_ledokol_exceptions`")

if (res) and (rows > 0) then
for x = 0, rows - 1 do
res, entry, occured = VH:SQLFetch (x)

if string.find (lowtxt, entry) then
occured = occured + 1
res, err = VH:SQLQuery ("update `script_ledokol_exceptions` set `occured`='"..occured.."' where `exception`='"..repsqlchars (entry).."' limit 1")

if notifyex == 1 then
cmsg = string.format (gettranslation ("lang_183"), nick, getip (nick), unclass, text)
VH:SendPMToAll (cmsg, feednick, classnotiex, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end

res, err = VH:SQLFree ()

return 1
end
end
end

if notifyanti == 1 then
cmsg = string.format (gettranslation ("lang_184"), nick, getip (nick), unclass, text)
VH:SendPMToAll (cmsg, feednick, classnotianti, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end

asaction = tonumber (aaction)

if asaction == 4 then
maintoself (nick, text)
else
maintouser (nick, antimessage)
end

if addledobot == 1 then
sendfrom = ledobotnick
else
sendfrom = botnick
end

if asaction == 1 then
res, err = VH:CloseConnection (nick)

if notifyanti == 1 then
cmsg = string.format (gettranslation ("lang_203"), nick)
VH:SendPMToAll (cmsg, feednick, classnotianti, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end

elseif asaction == 2 then
res, err = VH:KickUser (sendfrom, nick, string.gsub (antikreason, "%*", text))

if notifyanti == 1 then
cmsg = string.format (gettranslation ("lang_204"), nick)
VH:SendPMToAll (cmsg, feednick, classnotianti, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end

elseif asaction == 3 then
res, err = VH:KickUser (sendfrom, nick, string.gsub (antikreason, "%*", text).." ledo_ban_"..thirdacttime)

if notifyanti == 1 then
cmsg = string.format (gettranslation ("lang_205"), nick, thirdacttime)
VH:SendPMToAll (cmsg, feednick, classnotianti, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end

elseif asaction == 4 then
if notifyanti == 1 then
cmsg = string.format (gettranslation ("lang_216"), nick)
VH:SendPMToAll (cmsg, feednick, classnotianti, 10)

if (histrunning == 1) and (histbotmsg == 1) and ((notifytoledobot == 0) or (addledobot == 0)) then
addophistoryline (opchatnick, cmsg)
end
end
end

res, err = VH:SQLFree ()

return 0
end
end
end

res, err = VH:SQLFree ()
end

return 1
end

-- scan text functions end

-- chat functions begin

function maintouser (nick, message)
if addledobot == 1 then
sendfrom = ledobotnick
else
sendfrom = botnick
end

VH:SendDataToUser ("<"..sendfrom.."> "..message.."|", nick)

return 0
end

function maintoself (nick, message)
VH:SendDataToUser ("<"..nick.."> "..message.."|", nick)

return 0
end

function offlinepm (from, to, message)
VH:SendDataToUser ("$To: "..to.." From: "..from.." $<"..from.."> "..message.."|", to)

return 0
end

function pmfrombot (to, message)
if addledobot == 1 then
sendfrom = ledobotnick
else
sendfrom = botnick
end

VH:SendDataToUser ("$To: "..to.." From: "..botnick.." $<"..sendfrom.."> "..message.."|", to)

return 0
end

function pmtouser (to, from, message)
if addledobot == 1 then
sendfrom = ledobotnick
else
sendfrom = botnick
end

VH:SendDataToUser ("$To: "..to.." From: "..from.." $<"..sendfrom.."> "..message.."|", to)

return 0
end

-- chat functions end

-- end of file